if (!sape) var sape = {};
if (!sape.antigate) sape.antigate =
{
    API: '',
    queue: [],
    queueTimer: null,
}

sape.antigate.getImage = function(url)
{
    var ioserv  = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var channel = ioserv.newChannel(url, 0, null);
    var stream  = channel.open();

    if (channel instanceof Components.interfaces.nsIHttpChannel && channel.responseStatus != 200 && channel.responseStatus != 302) return "";

    var bstream = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
    bstream.setInputStream(stream);

    var data = '', size = 0;
    while (size = bstream.available()) data += bstream.readBytes(size);

    return data;
}

sape.antigate.queueManager = function()
{
    var ag = sape.antigate;
    if (ag.queueTimer && !ag.queue.length)
    {
        ag.queueTimer.cancel();
        return;
    }
    while (ag.queue.length)
    {
        var task = ag.queue.shift();

        if (!task.ID) ag.recognize(task);
        if (task.ID && !task.code) ag.check(task);
        if (task.ID &&  task.code) ag.send(task);
    }
}

sape.antigate.queueStart = function(task)
{
    var ag = sape.antigate;
    if (task) ag.queue.push(task);
    if (!ag.queueTimer)
    {
        ag.queueTimer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
    }
    ag.queueTimer.initWithCallback({notify: function(timer){sape.antigate.queueManager()}}, 3000, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
}

sape.antigate.recognize = function(task)
{
    var st = sape.toolbar, ag = sape.antigate, nl = "\r\n", nl2 = "\r\n\r\n";
    var boundary = "XX" + Math.random();

    var data  = '--' + boundary + nl;
        data += 'Content-Disposition: form-data; name="method"' + nl2 + 'post' + nl;
        data += '--' + boundary + nl;
        data += 'Content-Disposition: form-data; name="key"' + nl2 + sape.antigate.API + nl;
        data += '--' + boundary + nl;
        data += 'Content-Disposition: form-data; name="soft_id"' + nl2 + '150' + nl;
        data += '--' + boundary + nl;
        data += 'Content-Disposition: form-data; name="file"; filename="capcha.gif"' + nl + 'Content-Type: image/gif' + nl2 + task.imgData;
        data += '--' + boundary + nl;
        data += 'Content-Disposition: form-data; name="numeric"' + nl2 + '0' + nl;
        data += '--' + boundary + '--';

    var req = new XMLHttpRequest();
        req.open('POST', 'http://antigate.com/in.php', true);
        req.setRequestHeader('Content-Type', 'multipart/form-data; boundary=' + boundary);
        req.setRequestHeader('Content-Length', data.length);

    var requestTimer = st.reqTimer(req, 15000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            requestTimer.cancel();
            if (req.status == 200 && req.responseText.length)
            {
                if (req.responseText.match(/^OK/))
                {
                    task.ID = req.responseText.split('|')[1];
                    ag.queueStart(task);

                    st.showAlert(st.str("ag.recognize"), "Antigate.com", 0, task.imgInfo);
                    return;
                }
                else
                {
                    if (req.responseText.match(/NO_SLOT_AVAILABLE/))
                    {
                          ag.queueStart(task);
                          return;
                    }
                    var msg = '';
                    if (req.responseText.match(/WRONG_USER_KEY|KEY_DOES_NOT_EXIST/))
                    {
                        msg = st.str("ag.key.error");
                        ag.queue = [];
                    }
                    if (req.responseText.match(/IP_NOT_ALLOWED/))
                    {
                        msg = st.str("ag.ip.error");
                        ag.queue = [];
                    }
                    if (req.responseText.match(/ZERO_CAPTCHA_FILESIZE|TOO_BIG_CAPTCHA_FILESIZE|WRONG_FILE_EXTENSION/))
                    {
                        msg = st.str("ag.format.error");
                    }
                    if (msg.length) st.showAlert(msg, "Antigate.com", 0, task.imgInfo);
                    else            st.showAlert(req.responseText, "Antigate.com", 0, task.imgInfo);
                }
            }
            else
            {
                sape.antigate.queueStart(task);
            }
        }
    }
    try {req.sendAsBinary(data);} catch(e) {req.abort()}
}

sape.antigate.check = function(task)
{
    var req = new XMLHttpRequest();
    req.open('GET', 'http://antigate.com/res.php?action=get&key=' + sape.antigate.API + '&id=' + task.ID, true);
    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseText.length)
            {
                var result = req.responseText;
                if (result.match(/^OK/))
                {
                    task.code = result.split('|')[1];
                    sape.antigate.send(task);
                    return;
                }
                if (!result.match(/^ERROR/))
                {
                    sape.antigate.queueStart(task);
                }
            }
        }
    }
    try {req.send(null)} catch(e) {req.abort()}
}

sape.antigate.send = function(task)
{
    var sendURL = '';
    if (task.host.indexOf('tut.by') > -1) sendURL = 'http://' + task.host + '/?captcha=1&key='   + encodeURIComponent(task.key) + '&captcha_code=' + task.code;
    if (task.host.indexOf('yandex') > -1) sendURL = 'http://' + task.host + '/checkcaptcha?key=' + encodeURIComponent(task.key) + '&retpath=' + encodeURIComponent('http://' + task.host) + '&rep=' + task.code;
    if (task.host.indexOf('google') > -1) sendURL = 'http://' + task.host + '/sorry/Captcha?id=' + task.key + '&continue=' + encodeURIComponent('http://' + task.host) + '&captcha=' + task.code;

    var req = new XMLHttpRequest();
        req.open('GET', sendURL, true);
        req.onreadystatechange = function(aEvt)
        {
            if (req.readyState == 4)
            {
                if (task.caller.cTimer && task.caller.doc)
                {
                    task.caller.cTimer = 0;
                    task.caller.inProgress = 1;
                    task.caller.nextone();
                }
            }
        }
    try {req.send(null)} catch(e) {req.abort()};
}

sape.antigate.addTask = function(caller, req)
{
    var m, task =
    {
        ID: 0,        // ID   antigate
        imgURL: '',   //    
        imgData: '',  //  
        code: '',     //   
        type: '',     //  
        key: '',      //    (key    tut.by, id  google)
        caller: null, // ,      
        imgInfo: 'chrome://wmsape/skin/yandex.png',
    };
    for (var i=0; i < sape.antigate.queue.length; i++)
    {
        if (sape.antigate.queue[i].caller == caller) return;
    }
    task.host = req.channel.URI.host;

    if ((task.host.indexOf('yandex') > -1) && (req.channel.URI.path.indexOf('showcaptcha') > -1))
    {
        if (m = req.responseText.match(/name\=\"key\"[^>]*value\=\"([^\"]+)/))     task.key = m[1];
        if (m = req.responseText.match(/\/captchaimg\?[^\"]+/))                    task.imgURL = 'http://' + task.host + m[0];
        if (m = req.responseText.match(/[a-z\.]+.yandex.net\/image\?key=[^\"]+/))  task.imgURL = 'http://' + m[0];
    }
    if (task.host.indexOf('tut.by') > -1)
    {
        task.imgInfo = 'chrome://wmsape/skin/tut.png';
        if (m = req.responseText.match(/yandex.ru\/captchaimg\?[^\"]+/))           task.imgURL = 'http://' + m[0];
        if (m = req.responseText.match(/name\=\"key\"[^>]*value\=\"([^\"]+)/))     task.key = m[1];
    }
    if ((task.host.indexOf('google') > -1) && (req.channel.URI.path.indexOf('/sorry/') > -1))
    {
        task.imgInfo = 'chrome://wmsape/skin/google.png';
        if (m = req.responseText.match(/\"id\"\s*value\=\"([^\"]+)\"/)) task.key = m[1];
        if (req.responseText.indexOf('sorry/image?id') > -1)            task.imgURL = 'http://' + task.host + '/sorry/image?id=' + task.key + '&hl=ru';
    }
    if (task.key.length && task.imgURL)
    {
        task.caller  = caller;
        task.imgData = sape.antigate.getImage(task.imgURL);
        sape.antigate.queueStart(task);
    }
    else
    {
       sape.toolbar.showAlert(sape.toolbar.str("ag.no.captcha"), "Antigate.com", 0, task.imgInfo);
    }
}
