if (!sape) var sape={};
if (!sape.toolbar) sape.toolbar={};

//------------------------------------------------------------------------------
// Bing
//------------------------------------------------------------------------------

if (!sape.toolbar.bing) sape.toolbar.bing =
{
    bingurl: 'http://www.bing.com/search?q=',
    bingapi: 'http://api.search.live.net/xml.aspx?Appid=508F2158A855BA0D079B639C03E16804DA5D51F1&sources=web&query=',
    sapi: 'http://xml.solomono.ru/?s=api2&url=',
    surl: 'http://solomono.ru/default.aspx',
    inProgress: 0,
    doc: null,
    lc: -1,
    icache: true,
    lay: {},
    total: {},
    average: {},
    type: 1, /* 1 - solomono, 0 - bing */
    img: "chrome://wmsape/skin/bing.png",
};

sape.toolbar.bing.show = function(host, place, text)
{
    var st = sape.toolbar, me = st.bing, doc = place.ownerDocument;
    var parts = text.toString().split('|');

    var b = doc.createElement('b');
        b.style.color = 'green';
        b.style.cursor = 'help';
        b.title = st.str("bing.help");
        b.textContent = (me.type)? 'S:\xA0' : 'B:\xA0';

    var l1 = doc.createElement('a');
        l1.target = '_blank';
        l1.style.color = 'black';
        l1.appendChild(doc.createTextNode(parts[0]));
        l1.title = st.str("bing.total");

    if (!me.type)
    {
        l1.href = me.bingurl + encodeURIComponent('linkfromdomain:' + host.split('/')[2]);
    }
    else
    {
        if (me.domains) { l1.href = me.surl + '?r=16&i=' + encodeURIComponent(host.split('/')[2]); l1.title = st.str("bing.domains"); }
        else            { l1.href = me.surl + '?r=15&i=' + encodeURIComponent(host.split('/')[2]); }
    }
    place.appendChild(doc.createTextNode(' '));
    place.appendChild(b);
    place.appendChild(doc.createTextNode('['));
    place.appendChild(l1);

    if (parts.length == 3)
    {
        var l2 = doc.createElement('a');
            l2.target = '_blank';
            l2.style.color = 'black';
            l2.appendChild(doc.createTextNode(parts[1]));
            l2.title = st.str("bing.pages");

        if (!me.type) {l2.href = me.bingurl + encodeURIComponent('site:' + host.split('/')[2]);}
        else          {l2.href = me.surl + '?r=13&i=' + encodeURIComponent(host.split('/')[2]);}

        place.appendChild(doc.createTextNode('\xA0/\xA0'));
        place.appendChild(l2);
        place.appendChild(doc.createTextNode('\xA0/\xA0'));
        place.appendChild(doc.createTextNode(parts[2]));
    }
    place.appendChild(doc.createTextNode(']\xA0'));
};

sape.toolbar.bing.getResult = function(text)
{
    var st = sape.toolbar, me = st.bing;

    if (text.indexOf('div id="no_results"') > -1) return 0;

    var res = text.match(/\"sb_count\"\sid\=\"count\">([^<]+)</);
    if (res)
    {
        var txt = st.html2text(res[1], me.doc).replace(/[^\d]+/g, '');
        return parseInt(txt, 10);
    }
    return 0;
};

sape.toolbar.bing.getAverage = function(host, place, checkbox, total)
{
    var st  = sape.toolbar, me = st.bing, doc = place.ownerDocument;
    var url = me.bingurl + encodeURIComponent('site:' + host.split('/')[2]);

    var loader = doc.createElement("img");
        loader.src = 'http://static.sape.ru/common/img/ajax-loader-plugin.gif';

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', url, true);
        req.setRequestHeader('Referer', 'http://bing.com/');

    var requestTimer = st.reqTimer(req, 15000);

    req.onreadystatechange = function (aEvt)
    {
        var correct = 0;
        if (req.readyState == 4)
        {
                requestTimer.cancel();
                if (loader) place.removeChild(loader);

                if (req.status == 200 && req.responseText.length)
                {
                        var pages = me.getResult(req.responseText);
                        var average = (pages == 0)? 0 : (total/pages).toFixed(2);

                        if (me.icache) st.cache.push(host, 'bingp', pages);
                        if (me.average.check && (average > (me.average.limit / me.average.pages))) checkbox.checked = true;

                        me.show(host, place, total.toString() + '|' + pages.toString() + '|' + average.toString());
                        return;
                }
                me.show(host, place, 'n/a');
        }
    }
    place.appendChild(loader);
    req.send(null);
};

sape.toolbar.bing.runBing = function(host, place, checkbox)
{
    var st  = sape.toolbar, me = st.bing, doc = place.ownerDocument;
    var url = me.bingurl + encodeURIComponent('linkfromdomain:' + host.split('/')[2]);

    var loader = doc.createElement("img");
        loader.src = 'http://static.sape.ru/common/img/ajax-loader-plugin.gif';

    if  (place.hasAttribute("bing_rank")) return;
    else place.setAttribute("bing_rank", 1);

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');

    var requestTimer = st.reqTimer(req, 15000);

    req.onreadystatechange = function (aEvt)
    {
        var correct = 0;
        if (req.readyState == 4)
        {
                requestTimer.cancel();
                if (loader) place.removeChild(loader);

                if (req.status == 200 && req.responseText.length)
                {
                    var total = me.getResult(req.responseText);
                    if (me.average.check)
                    {
                        me.getAverage(host, place, checkbox, total);
                        correct = 1;
                    }
                    else
                    {
                        me.show(host, place, total.toString());
                        correct = 1;
                    }
                    if (me.icache) st.cache.push(host, 'bingt', total);
                    if (me.total.check && (total > me.total.limit)) checkbox.checked = true;
                }
                if (!correct)
                {
                    me.show(host, place, 'n/a');
                }
                me.next((me.average.check)? 500 : 250);
        }
    }
    place.appendChild(loader);
    req.send(null);
};

sape.toolbar.bing.runSolo = function(host, place, checkbox)
{
    var st  = sape.toolbar, me = st.bing, doc = place.ownerDocument;
    var url = me.sapi + encodeURIComponent(host.split('/')[2]);

    var loader = doc.createElement("img");
        loader.src = 'http://static.sape.ru/common/img/ajax-loader-plugin.gif';

    if  (place.hasAttribute("bing_rank")) return;
    else place.setAttribute("bing_rank", 1);

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');

    var requestTimer = st.reqTimer(req, 15000);

    req.onreadystatechange = function (aEvt)
    {
        var correct = 0;
        if (req.readyState == 4)
        {
                requestTimer.cancel();
                if (loader) place.removeChild(loader);

                if (req.status == 200 && req.responseText.length)
                {
                    var xml = req.responseXML;

                    var pages_indexed = xml.getElementsByTagName("pages_indexed");
                    var pages = (pages_indexed && pages_indexed.length)? parseInt(pages_indexed[0].textContent, 10) : 0;

                    var hrefsout = xml.getElementsByTagName("hrefsout");
                    var domout   = xml.getElementsByTagName("domout");

                    var hrefs   = (hrefsout && hrefsout.length)? parseInt(hrefsout[0].textContent, 10) : 0;
                    var domains = (domout && domout.length)? parseInt(domout[0].textContent, 10) : 0;

                    if (pages_indexed.length && hrefsout.length && domout.length) correct = 1;
                    if (correct)
                    {
                        var total = (me.domains)? domains : hrefs;
                        var average = (pages == 0)? 0 : (total/pages).toFixed(2);

                        if (me.total.check && (total > me.total.limit)) checkbox.checked = true;
                        if (me.average.check && (average > (me.average.limit / me.average.pages))) checkbox.checked = true;

                        if (me.icache) st.cache.push(host, 'solp', pages);
                        if (me.icache) st.cache.push(host, 'solh', hrefs);
                        if (me.icache) st.cache.push(host, 'sold', domains);

                        if (me.average.check) {me.show(host, place, total.toString() + '|' + pages.toString() + '|' + average.toString());}
                        else                  {me.show(host, place, total.toString());                                                    }
                    }
                }
                if (!correct)
                {
                    me.show(host, place, 'n/a');
                }
                me.next(250);
        }
    }
    place.appendChild(loader);
    req.send(null);
};

sape.toolbar.bing.next = function()
{
      var st = sape.toolbar, me = st.bing;
      if (me.inProgress) st.setTimer(me.nextone, (arguments.length)? arguments[0] : 250);
};

sape.toolbar.bing.nextone = function()
{
    var st = sape.toolbar, me = st.bing;
    if (!me.inProgress) return;

    var row = me.doc.getElementsByTagName('tr');

    if (me.doc.defaultView) for (var i=0; i < row.length; i++)
    {
        var col = row[i].getElementsByTagName('td');
        if (col.length < me.lay.cols) continue;

        var box = col[me.lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.idx + 1) continue;

        var href  = a[me.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var link = st.getURL(href);

        var host = link.split('/')[2].replace(/^www\./i, '');
            host = 'http://' + host + '/';

        var divs = col[me.lc].getElementsByTagName('div'), place = null;
        if (divs) for (var j=0; j< divs.length; j++)
        {
            if (divs[j].className.indexOf('page_icons') > -1)
            {
                place = divs[j];
                break;
            }
        }
        if (!place)
        {
            var div = me.doc.createElement('div');
            div.className = 'page_icons';
            col[me.lc].appendChild(div);
            place = div;
        }
        if (place.hasAttribute('bing_rank')) continue;

        if (me.icache)
        {
            var total = (me.type)? st.cache.pop(host, ((me.domains)? 'sold' : 'solh')) : st.cache.pop(host, 'bingt');
            var pages = (me.type)? st.cache.pop(host, 'solp') : st.cache.pop(host, 'bingp');

            if ((pages !== null) && (total !== null) && me.average.check)
            {
                var average = (pages == 0)? 0 : (total/pages).toFixed(2);

                if (me.total.check && (total > me.total.limit)) box[0].checked = true;
                if (me.average.check && (average > (me.average.limit / me.average.pages))) box[0].checked = true;

                me.show(host, place, total.toString() + '|' + pages.toString() + '|' + average.toString());
                place.setAttribute("bing_rank", 1);
                continue;
            }
            if ((total !== null) && !me.average.check)
            {
                if (me.total.check && (total > me.total.limit)) box[0].checked = true;

                me.show(host, place, total.toString());
                place.setAttribute("bing_rank", 1);
                continue;
            }
        }

        if (!place.hasAttribute('bing_rank'))
        {
            if (!me.type) { st.bing.runBing(host, place, box[0]); }
            else          { st.bing.runSolo(host, place, box[0]); }

            return;
        }
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('nice'), st.str('ya.finish'), 2, me.img);
    }
};

sape.toolbar.bing.unload = function()
{
    var me = sape.toolbar.bing;

    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.toolbar.bing.start = function()
{
    var st = sape.toolbar, me = st.bing;
    if (!st.inside(content.document)) return;

    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('bad'), st.str('ya.stop'), 2, me.img);
        return;
    }
    if (me.doc) me.unload();

    me.doc = content.document;

    var lay = st.layout(me.doc);
    me.lc   = (lay.url == -1)? lay.link : lay.url;
    me.idx  = lay.idx;
    me.lay  = lay;

    if (me.lc < 0) return;

    var prefs = st.prefs();
    me.icache = prefs.getBoolPref("cache");

    me.total.check = prefs.getBoolPref("bing.total.check");
    me.total.limit = prefs.getIntPref("bing.total");

    me.average.check = prefs.getBoolPref("bing.average.check");
    me.average.limit = prefs.getIntPref("bing.average");
    me.average.pages = Math.max(1, prefs.getIntPref("bing.pages"));

    me.type = prefs.getIntPref("bing.type");
    me.domains = prefs.getBoolPref("bing.domains");

    me.img = (me.type)? "chrome://wmsape/skin/solomono.png" : "chrome://wmsape/skin/bing.png";

    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, me.img);

    me.doc.defaultView.addEventListener('unload', me.unload, false);

    me.next(500);
    if (!me.average.check) me.next(1000);
};