if (!sape) var sape={};
if (!sape.blacklist) sape.blacklist =
{
    urls: [],
    file: null,
};

sape.blacklist.init = function()
{
    var st = sape.toolbar;
    var prefs = st.prefs();

    var path = prefs.getCharPref("blacklist.filename");
    if (!path)
    {
        var localFile = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
            localFile.append("wmsape-list.txt");

        prefs.setCharPref("blacklist.filename", st.unicode.decode(localFile.path));
        this.file = localFile;
    }
    else
    {
        var localFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
            localFile.initWithPath(st.unicode.encode(path));

        this.file = localFile;
    }
    this.urls = [];

    if (!this.file.exists()) return;

    var fileStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
        fileStream.init(this.file, 1, 0, false);
    var inputStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
        inputStream.init(fileStream);

    var data = inputStream.read(-1);

    fileStream.close();
    inputStream.close();

    var line = '', lines = data.split(/[\r\n]+/);

    for (var i=0; i<lines.length; i++)
    {
        if (lines[i].length > 1)
        {
            try
            {
                line = st.unicode.encode(lines[i].toString());
            }
            catch(e)
            {
                line = lines[i].toString();
            }
            this.urls.push(line);
        }
    }
};

sape.blacklist.save = function()
{
    if (!this.file) return;

    var data = this.urls.join("\n");
    try
    {
        Components.utils.import("resource://gre/modules/NetUtil.jsm");
        Components.utils.import("resource://gre/modules/FileUtils.jsm");

    	var ostream = FileUtils.openSafeFileOutputStream(this.file);
    	var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
        	converter.charset = "UTF-8";

    	var istream = converter.convertToInputStream(data);

    	NetUtil.asyncCopy(istream, ostream);
    }
    catch(e){}
};

//------------------------------------------------------------------------------
//     
//------------------------------------------------------------------------------
sape.blacklist.onLoad = function()
{
    this.init();

    var namebox = document.getElementById('wmsape-lbl-filename');
        namebox.value = this.file.path;

    this.showList(this.file);

    var list = document.getElementById('wmsape-lbl-urls');
    if (list) list.focus();

    return true;
};

sape.blacklist.onAccept = function()
{
    var st = sape.toolbar;
    var namebox = document.getElementById('wmsape-lbl-filename');

    var prefs = st.prefs();
        prefs.setCharPref("blacklist.filename", st.unicode.decode(namebox.value));

    var localFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        localFile.initWithPath(namebox.value);

    var urlbox = document.getElementById('wmsape-lbl-urls');
    var elmbox = document.getElementById('wmsape-lbl-elem');
    var secbox = document.getElementById('wmsape-lbl-sections');
    try
    {
        Components.utils.import("resource://gre/modules/NetUtil.jsm");
        Components.utils.import("resource://gre/modules/FileUtils.jsm");

    	var ostream = FileUtils.openSafeFileOutputStream(localFile);
    	var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
        	converter.charset = "UTF-8";

        var data = elmbox.value;
        if (secbox.value) data += "\n" + secbox.value;
        if (urlbox.value) data += "\n" + urlbox.value;

    	var istream = converter.convertToInputStream(data);

    	NetUtil.asyncCopy(istream, ostream);
    }
    catch(e){}

    return true;
};

sape.blacklist.onSort = function()
{
    try
    {
        var urlbox = document.getElementById('wmsape-lbl-urls');
        var data = urlbox.value;

        urlbox.value = data.split(/[\n\r]+/).sort().join('\n');
    }
    catch(e){}
    try
    {
        var elmbox = document.getElementById('wmsape-lbl-elem');
        var data = elmbox.value;

        elmbox.value = data.split(/[\n\r]+/).sort().join('\n');
    }
    catch(e){}
    try
    {
        var secbox = document.getElementById('wmsape-lbl-sections');
        var data = secbox.value;

        secbox.value = data.split(/[\n\r]+/).sort().join('\n');
    }
    catch(e){}
};

sape.blacklist.onSelect = function()
{
    var st = sape.toolbar;
    var namebox = document.getElementById('wmsape-lbl-filename');

    var localFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        localFile.initWithPath(namebox.value);

    var localDir  = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        localDir.initWithPath(localFile.path.replace(localFile.leafName, ''));

    var nsIFilePicker = Components.interfaces.nsIFilePicker;

    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
        fp.init(window, null, nsIFilePicker.modeLoad);
        fp.displayDirectory = localDir;
        fp.defaultString = localFile.leafName;
        fp.appendFilters(nsIFilePicker.filterText);

    var res = fp.show();
    if (res !== nsIFilePicker.returnOK) return

    namebox.value = fp.file.path;
    this.showList(fp.file);
};

sape.blacklist.showList = function(localFile)
{
    var st = sape.toolbar;
    var urlbox = document.getElementById('wmsape-lbl-urls');
    var elmbox = document.getElementById('wmsape-lbl-elem');
    var secbox = document.getElementById('wmsape-lbl-sections');

    if (!localFile.exists())
    {
        urlbox.value = '';
        elmbox.value = '';
        secbox.value = '';
        return;
    }

    var fileStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
        fileStream.init(localFile, 1, 0, false);
    var inputStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
        inputStream.init(fileStream);

    var data = inputStream.read(-1);

    fileStream.close();
    inputStream.close();

    var urls = [], elems = [], sections = [];
    var lines = data.split(/[\n\r]+/);

    for (var i=0; i < lines.length; i++)
    {
        var line = '';
        if (lines[i].toString().length)
        {
                try
                {
                    line = st.unicode.encode(lines[i].toString());
                }
                catch(e)
                {
                    line = lines[i].toString();
                }
                if (line.match(/^https?\:/))
                {
                    if (line.match(/\*$/))
                    {
                        sections.push(line);
                    }
                    else
                    {
                        urls.push(line);
                    }
                }
                else
                {
                    elems.push(line);
                }
        }
    }
    urlbox.value = urls.join('\n');
    elmbox.value = elems.join('\n');
    secbox.value = sections.join('\n');
};

//------------------------------------------------------------------------------
//    
//------------------------------------------------------------------------------

sape.blacklist.add = function()
{
   var st  = sape.toolbar;
   var doc = content.document;
   var lay = st.layout(doc);

   var lc = (lay.url < 0)? lay.link : lay.url;
   if (lc < 0) return;

   this.init();

   var total = 0, row  = doc.getElementsByTagName('tr');
   for (var i=0; i < row.length; i++)
   {
		var td = row[i].getElementsByTagName('td');
        if (td.length < lay.cols) continue;

        var box = td[lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;
        if (!st.boxCheck(box[0]) || !box[0].checked) continue;

        var a = td[lc].getElementsByTagName('a');
        if (a.length < lay.idx + 1) continue;

        var href = a[lay.idx].getAttribute('href');
        if (st.urlCheck(href) && (this.urls.indexOf(href) == -1))
        {
            this.urls.push(href);
            total++;
        }
   }
   this.save();

   if (!total) st.showAlert(st.str('links.no'), st.str('blacklist'), 0, "chrome://wmsape/skin/blacklist.png");
   else        st.showAlert(st.str('links.added') + ' ' + total, st.str('blacklist'), 0, "chrome://wmsape/skin/blacklist.png");
};

sape.blacklist.addhost = function()
{
   var st  = sape.toolbar;
   var doc = content.document;
   var lay = st.layout(doc);

   var lc = (lay.url < 0)? lay.link : lay.url;
   if (lc < 0) return;

   this.init();

   var total = 0, row  = doc.getElementsByTagName('tr');
   for (var i=0; i < row.length; i++)
   {
		var td = row[i].getElementsByTagName('td');
        if (td.length < lay.cols) continue;

        var box = td[lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;
        if (!st.boxCheck(box[0]) || !box[0].checked) continue;

        var a = td[lc].getElementsByTagName('a');
        if (a.length < lay.idx + 1) continue;

        var href = a[lay.idx].getAttribute('href');
        if (st.urlCheck(href))
        {
            var URI = st.getURI(href);
            var patch = URI.prePath + '*';

            if (this.urls.indexOf(patch) == -1)
            {
                this.urls.push(patch);
                total++;
            }
        }
   }
   this.save();

   if (!total) st.showAlert(st.str('links.no'), st.str('blacklist'), 0, "chrome://wmsape/skin/blacklist.png");
   else        st.showAlert(st.str('links.added') + ' ' + total, st.str('blacklist'), 0, "chrome://wmsape/skin/blacklist.png");
};

// -----------------------------------------------
//  URL 
// -----------------------------------------------

sape.blacklist.check  = function()
{
    var st  = sape.toolbar;
    var doc = content.document;
    var lay = st.layout(doc);

    var total = 0;
    var showalerts = st.prefs().getBoolPref("showalerts");

    var lc = (lay.url < 0)? lay.link : lay.url;
    if (lc < 0) return;

    this.init();
    var curls = [], celems = [];

    for (var j=0; j < this.urls.length; j++)
    {
        var url = this.urls[j].toString().toLowerCase().replace(/(^\s+)|(\s+$)/, '');
        if (!url.length) continue;

        if (url.match(/^https?\:/))
        {
            if (url.match(/\*$/))
            {
                celems.push(url.replace(/\*$/, ''));
            }
            else
            {
                curls.push(url);
            }
        }
        else celems.push(url.replace(/\*$/, ''));
    }
    var row  = doc.getElementsByTagName('tr');
    for (var i=0; i < row.length; i++)
    {
		var td = row[i].getElementsByTagName('td');
        if (td.length < lay.cols) continue;

        var box = td[lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;
        if (!st.boxCheck(box[0])) continue;

        var a = td[lc].getElementsByTagName('a');
        if (a.length < lay.idx + 1) continue;

        var href = a[lay.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;
        href = href.toLowerCase();

        var found = 0, txt = '';
        if (curls.indexOf(href) > -1)
        {
            found = 1;
        }
        else
        {
            for (var k=0; k < celems.length; k++)
            {
                if (href.indexOf(celems[k]) > -1)
                {
                    found = 1;
                    txt += ': ' + celems[k];
                    break;
                }
            }
        }
        if (found)
        {
            if (!(box[0].checked))
            {
                box[0].checked = true;
                total++;
            }
            a[lay.idx].setAttribute("style", "color:red !important; font-weight:bold !important; cursor:help;");
            a[lay.idx].title = st.str('ext.lbl') + txt;
        }
    }
    if (!arguments.length && (total > 0) && showalerts)
    {
        st.showAlert(st.str('links.checked') + ' ' + total, 'fun', 0, "chrome://wmsape/skin/blacklist.png");
    }
    return total;
};