if (!sape) var sape={};
if (!sape.toolbar) sape.toolbar={};

if (!sape.toolbar.cache) sape.toolbar.cache =
{
    lifetime: 24,
    historytime: 3,
};

sape.toolbar.cache.init = function()
{
    sape.toolbar.cache.lifetime = sape.toolbar.prefs().getIntPref("cache.lifetime");
    window.removeEventListener("load",  sape.toolbar.cache.init, false);
};

sape.toolbar.cache.done = function()
{
    if (sape.toolbar.cache.db.dbc) sape.toolbar.cache.db.cleanup();
    window.removeEventListener("unload", sape.toolbar.cache.done, false);
};

sape.toolbar.cache.push =  function(url, type, value)
{
    var me = sape.toolbar.cache;
    if (!me.db.dbc) me.db.init();
    if ( me.db.dbc) me.db.push(url, type, value);
};

sape.toolbar.cache.pop = function(url, type)
{
    var me = sape.toolbar.cache;
    if (!me.db.dbc) me.db.init();
    if ( me.db.dbc) return me.db.pop(url, type);
    else            return null;
};

sape.toolbar.cache.del = function(url, type)
{
    var me = sape.toolbar.cache;
    if (!me.db.dbc) me.db.init();
    if ( me.db.dbc) return me.db.del(url, type);
    else            return null;
};

sape.toolbar.cache.age = function(url, type)
{
    var me = sape.toolbar.cache;
    if (!me.db.dbc) me.db.init();
    if ( me.db.dbc) return me.db.age(url, type);
    else            return null;
};

//------------------------------------------------------------------------------
//     
//------------------------------------------------------------------------------

if (!sape.toolbar.cache.db) sape.toolbar.cache.db =
{
    dbc: null,
};

sape.toolbar.cache.db.init = function()
{
    var cache = sape.toolbar.cache, me = cache.db;
	if (!me.dbc)
	{
            try
            {
                var dbfile = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
    			    dbfile.append("wmsape.sqlite");

    			var storageService = Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);
                try
                {
                    me.dbc = storageService.openDatabase(dbfile);

      				me.dbc.executeSimpleSQL("CREATE TABLE IF NOT EXISTS base(type VARCHAR(8), len INTEGER, url LONGVARCHAR, value LONGVARCHAR, up DATETIME)");
	        		me.dbc.executeSimpleSQL("CREATE INDEX IF NOT EXISTS cmp_idx ON base(type, len)");
			        me.dbc.executeSimpleSQL("CREATE INDEX IF NOT EXISTS up_idx ON base(up)");
     				me.dbc.executeSimpleSQL("PRAGMA synchronous = NORMAL");
	    			me.dbc.executeSimpleSQL("PRAGMA journal_mode = WAL");
                }
                catch (e if e.result == Components.results.NS_ERROR_FILE_CORRUPTED)
                {
                    if (me.dbc) me.dbc.close();
                    if (dbfile) dbfile.remove(false);
                    throw e;
                }
            }
            catch(e){}
    }
};

sape.toolbar.cache.db.cleanup = function()
{
    var me = sape.toolbar.cache.db, statement;
	if (me.dbc)
	{
        try
        {
            var lifetime = sape.toolbar.prefs().getIntPref("cache.lifetime");
            var histime  = sape.toolbar.prefs().getIntPref("history.age") * 24 * 10;

            statement = me.dbc.createStatement('DELETE FROM base WHERE datetime(up) < datetime("now", "localtime", ?1) AND `type` <> "history"');
            statement.bindUTF8StringParameter(0, "-" + lifetime.toString() + " hour");
            statement.execute();
            statement.reset();

            statement = me.dbc.createStatement('DELETE FROM base WHERE datetime(up) < datetime("now", "localtime", ?1) AND `type` = "history"');
            statement.bindUTF8StringParameter(0, "-" + histime.toString() + " hour");
            statement.execute();
            statement.reset();

    		me.dbc.close();
	    	me.dbc = null;
        }
        catch (e) {}
	}
};

sape.toolbar.cache.db.drop = function()
{
    var cache = sape.toolbar.cache, me = cache.db;
	if (!me.dbc) me.init();
	if (me.dbc)
	{
        try
        {
    		me.dbc.executeSimpleSQL('DELETE FROM base WHERE `type` <> "history"');
            alert('Cache cleanup completed');
        }
        catch (e) {}
	}
};

sape.toolbar.cache.db.hdrop = function()
{
    var cache = sape.toolbar.cache, me = cache.db;
	if (!me.dbc) me.init();
	if (me.dbc)
	{
        try
        {
    		me.dbc.executeSimpleSQL('DELETE FROM base WHERE `type` = "history"');
            alert('History cleanup completed');
        }
        catch (e) {}
	}
};

sape.toolbar.cache.db.push = function(url, type, value)
{
    var me = sape.toolbar.cache.db, statement;
	if (me.dbc)
	{
        try
        {
           statement = me.dbc.createStatement("DELETE FROM base WHERE type=?1 AND len=?2 AND url=?3");

           statement.bindInt32Parameter(1, url.length);
           statement.bindUTF8StringParameter(0, type);
           statement.bindUTF8StringParameter(2, url);

           statement.execute();
           statement.reset();

           statement = me.dbc.createStatement("INSERT INTO base(type, len, url, value, up) VALUES (?1, ?2, ?3, ?4, datetime('now', 'localtime'))");

           statement.bindInt32Parameter(1, url.length);
           statement.bindUTF8StringParameter(0, type);
           statement.bindUTF8StringParameter(2, url);
           statement.bindUTF8StringParameter(3, value);

           statement.executeAsync();
        }
        catch(e) {}
    }
};

sape.toolbar.cache.db.del = function(url, type)
{
    var me = sape.toolbar.cache.db, statement;
	if (me.dbc)
	{
        try
        {
           statement = me.dbc.createStatement("DELETE FROM base WHERE type=?1 AND len=?2 AND url=?3");

           statement.bindInt32Parameter(1, url.length);
           statement.bindUTF8StringParameter(0, type);
           statement.bindUTF8StringParameter(2, url);

           statement.executeAsync();
        }
        catch(e) {}
    }
};

sape.toolbar.cache.db.pop = function(url, type)
{
    var me       = sape.toolbar.cache.db;
    var lifetime = sape.toolbar.cache.lifetime;

	if (me.dbc)
	{
        try
        {
			var statement = me.dbc.createStatement("SELECT value, up FROM base WHERE type=?1 AND len=?2 AND url=?3");
                statement.bindUTF8StringParameter(0, type);
                statement.bindUTF8StringParameter(2, url);
                statement.bindInt32Parameter(1, url.length);

			while (statement.executeStep())
			{
				var v = statement.getString(0);
                var t = statement.getString(1).match(/([0-9]+)\-([0-9]+)\-([0-9]+)\s([0-9]+)\:([0-9]+)\:([0-9]+)/);

                var cacheDate = new Date(t[1],t[2]-1,t[3],t[4],t[5],t[6],0);
                var lastDate =  new Date();
                lastDate.setHours(lastDate.getHours() - lifetime);

                if (cacheDate > lastDate)
                {
                    statement.reset();
                    return v;
                }
            }
            statement.reset();
        }
        catch(e) {}
    }
    return null;
};

//       null   
sape.toolbar.cache.db.age = function(url, type)
{
    var me = sape.toolbar.cache.db;

	if (me.dbc)
	{
        try
        {
			var statement = me.dbc.createStatement("SELECT up FROM base WHERE type=?1 AND len=?2 AND url=?3");
                statement.bindUTF8StringParameter(0, type);
                statement.bindUTF8StringParameter(2, url);
                statement.bindInt32Parameter(1, url.length);

			if (statement.executeStep())
			{
                var t = statement.getString(0).match(/([0-9]+)\-([0-9]+)\-([0-9]+)\s([0-9]+)\:([0-9]+)\:([0-9]+)/);
                var cacheDate = new Date(t[1],t[2]-1,t[3],t[4],t[5],t[6],0);
                var nowDate = new Date();

                statement.reset();
                return (nowDate - cacheDate) / 1000;
            }
            statement.reset();
        }
        catch(e) {}
    }
    return null;
};

// ----------------------------------- //

sape.toolbar.cache.notify = function(type, id, value)
{
    if (!id) return;
    var base = 'http://cache.sape.ru/set/' + type + '/' + id + '/';

    if (value !== null) base += value + '/';
    sape.toolbar.ping(base);
};

window.addEventListener("load",  sape.toolbar.cache.init, false);
window.addEventListener("unload", sape.toolbar.cache.done, false);
