if (!sape) var sape={};
if (!sape.filters) sape.filters =
{
    bgcolor: "pink",        // Цвет подсветки строк
    showalerts: true,       // Показывать всплывающие сообщения
    changeselect: true,     // Выбирать пункт "отказать"
    amorf: false,           // Нестрогое сравнение слов
    repeat: 3,              // Количество повторов
    chkspace: false,        // Задвоенные пробелы
    chkdot: true,           // Начинающиеся не с буквы
    chkcomma: true,         // Контроль пунктуации
    regexp: "",             // Регулярка для текстов
    regmod: "i",            // Модификатор регулярки
    layout: {},             // Разметка страницы
    trim: false,            // Удалять лишние пробелы в начале и конце текста
};

//------------------------------------------------------------------------------
// Инициализация
//------------------------------------------------------------------------------
sape.filters.init = function()
{
    var doc = content.document, f = sape.filters;
    var prefs = sape.toolbar.prefs();

    f.bgcolor       = prefs.getCharPref("bgcolor").replace(/[^0-9a-z#]+/ig,"");
    f.showalerts    = prefs.getBoolPref("showalerts");
    f.changeselect  = prefs.getBoolPref("changeselect");
    f.amorf         = prefs.getBoolPref("amorf");
    f.repeat        = prefs.getIntPref("repeat");
    f.chkspace      = prefs.getBoolPref("chkspace");
    f.chkdot        = prefs.getBoolPref("chkdot");
    f.chkcomma      = prefs.getBoolPref("chkcomma");
    f.regexp        = prefs.getCharPref("regexp");
    f.regmod        = prefs.getCharPref("regmod").replace(/[^igm]+/ig,"");
    f.layout        = sape.toolbar.layout(doc);
};

//------------------------------------------------------------------------------
// Поиск селекта с опциями отказа от заявок
//------------------------------------------------------------------------------

sape.filters.getSelect = function(doc)
{
    return doc.querySelector('select[name="requests_action"], select[name="act"]');
};

//------------------------------------------------------------------------------
// Запуск фильтра
//------------------------------------------------------------------------------

sape.filters.run = function(callback)
{
    var doc = content.document, f = sape.filters;
    if (!sape.toolbar.inside(doc)) return;

    f.init();

    if (f.layout.seo) return;
    if (f.layout.text == -1) return;

    var rows  = doc.getElementsByTagName('tr');
    var total = 0;
    for (var i = 0; i < rows.length; i++)
    {
        var cols = rows[i].getElementsByTagName('td');
        if (cols.length < f.layout.cols) continue;

        var o = cols[f.layout.check].getElementsByTagName("input");
        if (o.length == 0) continue;
        if (o[0].checked == true)  continue;

        if (o[0].id == "chk_all" || o[0].hasAttribute("onclick")) continue;

        if (cols[f.layout.text].innerHTML.indexOf('Context') != -1) continue;

        total += sape.filters[callback](rows[i]);
    }
    if (total > 0)
    {
        var select = f.getSelect(doc);

        if (f.changeselect && select && sape.toolbar.sape(doc))      {select.value = 'placementRemoveCause2'; select.value = 'delete_link_type_2';}

        if (f.showalerts) sape.toolbar.showAlert(sape.toolbar.str('links.checked') + ' ' + total, 'fun', 0, "chrome://wmsape/skin/button-" + callback + ".png");
    }
};

//------------------------------------------------------------------------------
// Запуск пользовательского фильтра
//------------------------------------------------------------------------------
sape.filters.user = function ()
{
    var doc = content.document, f = sape.filters;
    if (!sape.toolbar.inside(doc)) return;

    f.init();
    var prefs = sape.toolbar.prefs();

    var fn = new Array();
    fn[1]  = prefs.getBoolPref("mem.1");
    fn[2]  = prefs.getBoolPref("mem.2");
    fn[3]  = prefs.getBoolPref("mem.3");
    fn[4]  = prefs.getBoolPref("mem.4");
    fn[5]  = prefs.getBoolPref("mem.5");
    fn[8]  = prefs.getBoolPref("mem.8");
    fn[11] = prefs.getBoolPref("mem.11");
    fn[12] = prefs.getBoolPref("mem.12");
    fn[13] = prefs.getBoolPref("mem.13");
    fn[18] = prefs.getBoolPref("mem.18");

    var rows  = doc.getElementsByTagName('tr');
    var total = 0;

    if ((f.layout.text > -1) && !f.layout.seo)
    for (var i = 0; i < rows.length; i++)
    {
        var cols = rows[i].getElementsByTagName('td');
        if (cols.length < f.layout.cols) continue;

        var box = cols[f.layout.check].querySelector('input[type="checkbox"]');

        if (!box || box.checked || box.id.match(/check_all|chk_all/) || box.hasAttribute("onclick")) continue;

        if (cols[f.layout.text].innerHTML.indexOf('Context') != -1) continue;

        if (fn[1])  total += f[1](rows[i]);
        if (fn[2])  total += f[2](rows[i]);
        if (fn[3])  total += f[3](rows[i]);
        if (fn[4])  total += f[4](rows[i]);
        if (fn[5])  total += f[5](rows[i]);
        if (fn[8])  total += f[8](rows[i]);
        if (fn[11]) total += f[11](rows[i]);
        if (fn[12]) total += f[12](rows[i]);
        if (fn[13]) total += f[13](rows[i]);
    }
    if (fn[18]) total += sape.toolbar.ext.url(1);

    if (total > 0)
    {
        var select = f.getSelect(doc);

        if (f.changeselect && select && sape.toolbar.sape(doc)) {select.value = 'placementRemoveCause2'; select.value = 'delete_link_type_2';}

        if (f.showalerts) sape.toolbar.showAlert(sape.toolbar.str('links.checked') + ' ' + total, 'fun', 0, "chrome://wmsape/skin/button-6.png");
    }
};


//------------------------------------------------------------------------------
// Раскраска строк
//------------------------------------------------------------------------------

sape.filters.decorate = function(row, color)
{
    try
    {
        var col = row.getElementsByTagName('td');
        for (var i=0; i < col.length; i++)
        {
            if (!col[i].hasAttribute("trusted")) col[i].style.backgroundColor = color;
        }
    }
    catch(err) {};
};

//------------------------------------------------------------------------------
// Снять отметки
//------------------------------------------------------------------------------

sape.filters.cleanup = function ()
{
    var doc = content.document, f = sape.filters;
    if (!sape.toolbar.inside(doc)) return;

    f.init();

    var rows = doc.getElementsByTagName('tr');
    for (var i = 0; i < rows.length; i++)
    {
        try
        {
            var cols = rows[i].getElementsByTagName('td');
            if (cols.length !== f.layout.cols) continue;

            var box = cols[f.layout.check].querySelector('input[type="checkbox"]');

            if (!box || box.id.match(/check_all|chk_all|aSelectAll/) || box.hasAttribute("onclick")) continue;
            if (box.checked) box.checked = false;

            f.decorate(rows[i], '');
        }
        catch(err)
        {
            continue;
        }
    }
    try
    {
        f.getSelect(doc).options[0].selected = true;
    }
    catch(err) {};
};

//------------------------------------------------------------------------------
// Инвертировать отметки
//------------------------------------------------------------------------------

sape.filters.inverse = function ()
{
    var doc = content.document, f = sape.filters;
    if (!sape.toolbar.inside(doc)) return;

    f.init();

    var rows = doc.getElementsByTagName('tr');
    for (var i = 0; i < rows.length; i++)
    {
        try
        {
            var cols = rows[i].getElementsByTagName('td');
            if (cols.length !== f.layout.cols) continue;

            var box = cols[f.layout.check].querySelector('input[type="checkbox"]');

            if (!box || box.id.match(/check_all|chk_all|aSelectAll/) || box.hasAttribute("onclick")) continue;
            if (box.checked) f.decorate(rows[i], '');

            box.checked = !box.checked;
        }
        catch(err)
        {
            continue;
        }
    }
    try
    {
        f.getSelect(doc).options[0].selected = true;
    }
    catch(err) {};
};

//------------------------------------------------------------------------------
// Спрятать отмеченные строки
//------------------------------------------------------------------------------

sape.filters.drop = function ()
{
    var doc = content.document, f = sape.filters;
    if (!sape.toolbar.inside(doc)) return;

    f.init();
    var rows  = doc.getElementsByTagName('tr');
    var top   = rows.length - 1;

    for (var i = top; i >= 0; i--)
    {
        try
        {
            var cols = rows[i].getElementsByTagName('td');
            if (cols.length !== f.layout.cols) continue;

            var box = cols[f.layout.check].querySelector('input[type="checkbox"]');

            if (!box || box.id.match(/check_all|chk_all|aSelectAll/) || box.hasAttribute("onclick")) continue;
            if (box.checked == false)
            {
                rows[i].parentNode.removeChild(rows[i]);
            }
        }
        catch(err)
        {
            continue;
        }
    }
    try
    {
        f.getSelect(doc).options[0].selected = true;
    }
    catch(err) {};
};

//------------------------------------------------------------------------------
// Количество отмеченных строк
//------------------------------------------------------------------------------

sape.filters.ccount = function ()
{
    function get_price(cell)
    {
        var text = cell.textContent;

        var span = cell.querySelector('span');
        if (span) text = span.textContent;

        return parseFloat(text.replace(',', '.'));
    }

    var st = sape.toolbar, doc = content.document, ccnt = 0, cval = 0;
    if (st.inside(doc))
    {
        var lay = st.layout(doc);
        var rows = doc.getElementsByTagName('tr');

        if (lay.cols > 0)
        for (var i = 0; i < rows.length; i++)
        {
            var cols = rows[i].getElementsByTagName('td');
            if (cols.length < lay.cols) continue;

            var box = cols[lay.check].querySelector('input[type="checkbox"]:checked');
            if (box)
            {
                ccnt++;
                if (lay.price) cval += get_price(cols[lay.price]);
            }
        }
    }
    var sb = document.getElementById("wmsape-statusbar-panel-icon");
    var tt = (!ccnt)? st.str('menu.toggle.label') : st.str('links.checked') + ' ' + ccnt;

    if (ccnt && cval) tt += "\n" + st.str('addform.s4') + ' ' + cval.toFixed(2);

    if (sb) sb.setAttribute("tooltiptext", tt);
};

//------------------------------------------------------------------------------
// Повторные wait-заявки
//------------------------------------------------------------------------------

sape.filters.nowait =
{
    waitTimer: null,
    mess: '',

    addTask: function()
    {
        var me = sape.filters.nowait;
        var url = 'https://www.sape.ru/ajax_task.php?act=add&task=messageSearch';
        var req  = new XMLHttpRequest();
            req.open('POST', url, true);
            req.onreadystatechange = function (aEvt)
            {
                if (req.readyState == 4)
                {
                    me.waitTimer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
                    me.waitTimer.initWithCallback(sape.filters.nowait, 1000, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
                }
            }
            req.setRequestHeader('Content-Length', me.mess.length);
            req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            req.send(me.mess);
    },

    notify: function()
    {
        var me = sape.filters.nowait;
        var url = 'https://www.sape.ru/ajax_task.php?act=status&task=messageSearch';
        var req  = new XMLHttpRequest();
            req.open('POST', url, true);
            req.onreadystatechange = function (aEvt)
            {
                if (req.readyState == 4)
                {
                    if ((req.responseText.indexOf('"error":1') > -1) || (req.responseText.indexOf('"done":1') > -1))
                    {
                        me.waitTimer.cancel(); me.waitTimer = null;
                        if (req.responseText.indexOf('"done":1') > -1) me.getMessages();
                    }
                }
            }
            req.send(null);
    },

    getMessages: function()
    {
        var me = sape.filters.nowait;
        var url = 'https://www.sape.ru/messages.php' + me.mess;
        var req  = new XMLHttpRequest();
            req.open('GET', url, true);
            req.onreadystatechange = function (aEvt)
            {
                if (req.readyState == 4) me.markIt(req.responseText);
            }
            req.send(null);
    },

    markIt: function(responseText)
    {
        var st = sape.toolbar, f = sape.filters, me = f.nowait;
        var total = 0, url = "", urls = new Array(), URI, host;
        var uexp = /URL <b>([^<]+)/g; uexp.lastIndex = 0;

        while (url = uexp.exec(responseText))
        {
            URI  = st.getURI(url[1]);
            host = URI.asciiHost.toLowerCase();

            if (urls.indexOf(host) == -1) urls[urls.length] = host;
        }
        if (urls.length == 0)
        {
            if (f.showalerts) st.showAlert(st.str('nice'), st.str('links.no'), 0);
            return;
        }

        var blacklist = new RegExp(urls.join('|'), 'i');

        var rows = me.doc.getElementsByTagName('tr');
        for (var i=0; i < rows.length; i++)
      	{
            var col = rows[i].getElementsByTagName("td");
            if (col.length < me.lay.cols) continue;

            var box = col[me.lay.check].getElementsByTagName('input');
            if (box.length < 1) continue;

            var as = col[me.lc].getElementsByTagName('a');
            if (as.length < me.lay.idx + 1) continue;

            var href = as[me.lay.idx].getAttribute('href');
            if (!st.urlCheck(href)) continue;

            try
            {
                URI  = st.getURI(href);
                host = URI.asciiHost.toLowerCase();

                if (blacklist.test(host))
                {
                    f.decorate(rows[i], f.bgcolor);
                    if (rows[i].innerHTML.indexOf("icon_stat") > 0)
                    {
                        if (rows[i].innerHTML.indexOf("stat_wait") > 0)
                        {
                            if (!(box[0].checked))
                            {
                                box[0].checked = true;
                                total++;
                            }
                        }
                    }
                    else
                    {
                        if (!(box[0].checked))
                        {
                            box[0].checked = true;
                            total++;
                        }
                    }
                 }
            } catch(err){}
        }
        if (total > 0)
        {
            var select = f.getSelect(me.doc);
            if (f.changeselect && select) select.value = 'placementRemove';
            if (f.showalerts) st.showAlert(st.str('nice'), st.str('links.checked') + ' ' + total, 0);
        }
        else
        {
            if (f.showalerts) st.showAlert(st.str('nice'), st.str('links.no'), 0);
        }
    },

    start: function()
    {
        var f = sape.filters, me = f.nowait, st = sape.toolbar;

        if (!st.sape(content.document) || me.waitTimer) return;
        sape.filters.init();

        me.lay = st.layout(content.document);
        me.lc  = (me.lay.url < 0)? me.lay.link : me.lay.url;

        if (me.lc < 0) return;

        var m = me.lay.loc.match(/site_id\=([0-9]+)/);
        var site_id = (m)? parseInt(m[1], 10) : 0;

        me.mess = '?message_search=1&mode=&url_id_val=0&ps=500&user_type[]=2&site_id=' + site_id + '&message_type=4&word=%ED%E5+%E1%FB%EB%EE+%F0%E5%E0%EA%F6%E8%E8+%ED%E0+%EF%F0%E8%ED%FF%F2%F3%FE+%E7%E0%FF%E2%EA%F3';

        for (var i=0; i<16; i++)
        {
            var DT = new Date();
            DT.setDate(DT.getDate() - i);

            var DY = DT.getFullYear();

            var DM = DT.getMonth() + 1;
            if (DM < 10) DM = '0' + DM;

            var DD = DT.getDate();
            if (DD < 10) DD = '0' + DD;

            me.mess += '&dates[]=' + DY + '-' + DM + '-' + DD;
        }
        if (sape.filters.showalerts) st.showAlert(st.str('nice'), "WAIT please", 0);

        me.doc = content.document;
        me.addTask();
    },
};

//------------------------------------------------------------------------------
// Отметка по количеству страниц
//------------------------------------------------------------------------------
sape.filters.counters = function ()
{
    var st = sape.toolbar, doc = content.document;
    if (!st.inside(doc)) return;

    var r = doc.getElementsByTagName("tr");
    if (!r.length) return;

    var prefs    = st.prefs();
    var ycount   = prefs.getIntPref("pc.ycount");
    var gcount   = prefs.getIntPref("pc.gcount");
    var together = prefs.getBoolPref("pc.together");
    var diff     = prefs.getIntPref("pc.diff");
    var diffc    = prefs.getBoolPref("pc.diff.check");
    var ycheck   = prefs.getBoolPref("pc.ycheck"), yc;
    var gcheck   = prefs.getBoolPref("pc.gcheck"), gc;

    var lay  = st.layout(doc);

    var gexp = /G:<\/b>\s+\[([0-9]+)\]/;
    var yexp = /Я:<\/b>\s+\[([0-9]+)\]/;

    var counter = 0;
    for (var i=0; i < r.length; i++)
	{
        var col = r[i].getElementsByTagName("td");
        if (col.length < lay.cols) continue;

		var check = col[lay.check].getElementsByTagName("input");
        if (check.length == 0) continue;

        var html = r[i].innerHTML;

        yc = ((html.indexOf('blocked-in-yandex') > -1) && ycheck);
        gc = ((html.indexOf('blocked-in-google') > -1) && gcheck);

        var yandex = 0, google = 0, c = false;

        if (html.indexOf('class="not-blocked-in-yandex"') > 0)
        if (c = yexp.exec(html)) yandex = parseInt(c[1], 10);

        if (html.indexOf('class="not-blocked-in-google"') > 0)
        if (c = gexp.exec(html)) google = parseInt(c[1], 10);

        var checkit = false;

        // Проверяется один из параметров, второй отключен
        if (!yc && gc && (google < gcount)) checkit = true;
        if (!gc && yc && (yandex < ycount)) checkit = true;

        // Проверяются оба параметра сразу
        if (yc && gc)
        if (together)
        {
            if ((yandex < ycount) && (google < gcount)) checkit = true;
        }
        else
        {
            if ((yandex < ycount) || (google < gcount)) checkit = true;
        }

        // Сравнение количества страниц в G и Я
        if (diffc && !checkit)
        {
            if (html.indexOf('blocked-in-google') > -1)
            if (html.indexOf('blocked-in-yandex') > -1)
            {
                yandex = Math.max(yandex,1);
                google = Math.max(google,1);

                if ((yandex/google > diff) || (google/yandex > diff)) checkit = true;
            }
        }
        if (checkit)
        {
          check[0].checked = true
          counter++;

          sape.filters.decorate(r[i], prefs.getCharPref("bgcolor"));
        }
    }
    if (counter > 0)
        st.showAlert(st.str('nice'), st.str('links.checked') + ' ' + counter, 0);
    else
        st.showAlert(st.str('nice'), st.str('links.no'), 0);
};

//------------------------------------------------------------------------------
// Функция нестрогого сравнения
//------------------------------------------------------------------------------

sape.filters.morf = function(text1, text2)
{
    var f = sape.filters;
    var delta = 1; // порог погрешности

    if  (text1 == text2) return true;
    if  (f.amorf == false) return false;

    if ((text1.length < 4) || (text2.length < 4))   return false; // оба слова от 4 букв
    if  (Math.abs(text1.length - text2.length) > 1) return false; // разница в длине не более 1 буквы

    if ((text1.length > 6) || (text2.length > 6))  delta = 2; // для длинных слов погрешность сравнения больше

    var  ml = Math.min(text1.length, text2.length) - delta;

    return (text1.substr(0, ml) == text2.substr(0, ml))
};

//------------------------------------------------------------------------------
// Массив слов для анализа
//------------------------------------------------------------------------------

sape.filters.clearText = function(cell)
{
    var text = cell.innerHTML;
    var span = cell.getElementsByTagName("span");

    if (span.length)
    {
        for (var i=0; i< span.length; i++)
        {
            if (span[i].className.indexOf('txt_container') > -1) { text = span[i].innerHTML; break; }

            var p = s[i].getElementsByTagName('p');
            if (p.length) { text = s[i].innerHTML.replace(/<p[^>]+>([^<]+)<\/p>/, ''); break; }
        }
    }
    var text = text.replace(/<\/?u>/g, "")
                   .replace(/<span[^>]+>[^>]+<\/span>(\&nbsp\;)?/g, "")
                   .replace(/<div.*$/, "")
                   .replace(/<p.*$/, "")
                   .replace(/<[^<>]+>/g, "")
                   .replace(/ё/g, "е")
                   .replace(/Ё/g, "Е");

    if (sape.filters.trim) text = text.replace(/(^\s+)|(\s+$)/g, '');
    return text;
};

sape.filters.wordArray = function(cell)
{
    var f = sape.filters;
    var a = new Array();

    var text = f.clearText(cell);

    if (!text.length || text.match(/Context/g)) return a;

    text = text.replace(/[^0-9a-zа-яё]+/gi, " ")
               .replace(/\s\s+/g, " ")
               .replace(/(^\s+)|(\s+$)/g, '')
               .toLowerCase();

    var sa = text.split(" ");
    for (var j=0; j < sa.length; j++)
    {
        if (sa[j].length > 2) a.push(sa[j]);
    }
    return a;
};


//------------------------------------------------------------------------------
// Три одинаковых слова с учетом морфологии
//------------------------------------------------------------------------------

sape.filters[1] = function(row)
{
    var f   = sape.filters;
    var col = row.getElementsByTagName("td");

    var o = col[f.layout.check].getElementsByTagName("input");
    if (o[0].checked) return 0;

    var a = f.wordArray(col[f.layout.text]);

    for (var c=0; c < a.length; c++)
    {
            var counter = 1;
            for (var d = c+1; d < a.length; d++)
            {
                if (f.morf(a[c], a[d])) counter++;
            }
            if  (counter > f.repeat - 1)
            {
                f.decorate(row, f.bgcolor);
                o[0].checked = true;

                return 1;
            }
    }
    return 0;
};

//------------------------------------------------------------------------------
// Две пары с учетом морфологии
//------------------------------------------------------------------------------

sape.filters[2] = function(row)
{
    var f   = sape.filters;
    var col = row.getElementsByTagName("td");

    var o = col[f.layout.check].getElementsByTagName("input");
    if (o[0].checked) return 0;

    var a = f.wordArray(col[f.layout.text]);

    var counter = 0;
    for (var c=0; c < a.length - 2; c++)
    {
         for (var d=c+2; d < a.length-1; d++)
         {
                if (f.morf(a[c], a[d]) && f.morf(a[c+1], a[d+1]))
                {
                    counter++;
                    break;
                }
                if (f.morf(a[c], a[d+1]) && f.morf(a[c+1], a[d]))
                {
                    counter++;
                    break;
                }
        }
        if (counter > 0)
        {
            f.decorate(row, f.bgcolor);
            o[0].checked = true;

            return 1;
        }
  	}
    return 0;
};

//------------------------------------------------------------------------------
// Длина текста больше 50 символов
//------------------------------------------------------------------------------

sape.filters[3] = function(row)
{
    var f   = sape.filters;
    var col = row.getElementsByTagName("td");

    var o = col[f.layout.check].getElementsByTagName("input");
    if (o[0].checked) return 0;

    var text = f.clearText(col[f.layout.text]);

    if (text.length > 50)
    {
        f.decorate(row, f.bgcolor);
        o[0].checked = true;

        return 1;
    }
    return 0;
};

//------------------------------------------------------------------------------
// Длина текста больше 75 символов
//------------------------------------------------------------------------------

sape.filters[4] = function(row)
{
    var f   = sape.filters;
    var col = row.getElementsByTagName("td");

    var o = col[f.layout.check].getElementsByTagName("input");
    if (o[0].checked) return 0;

    var text = f.clearText(col[f.layout.text]);

    if (text.length > 75)
    {
        f.decorate(row, f.bgcolor);
        o[0].checked = true;

        return 1;
    }
    return 0;
};

//------------------------------------------------------------------------------
// Заявки без русских букв
//------------------------------------------------------------------------------

sape.filters[5] = function(row)
{
    var f   = sape.filters;
    var col = row.getElementsByTagName("td");

    var o = col[f.layout.check].getElementsByTagName("input");
    if (o[0].checked) return 0;

    var text = f.clearText(col[f.layout.text]);

    if (text.length && (text.length == text.replace(/[а-я]+/ig, "").length))
    {
        f.decorate(row, f.bgcolor);
        o[0].checked = true;

        return 1;
    }
    return 0;
};

//------------------------------------------------------------------------------
// Два слова подряд с учетом морфологии
//------------------------------------------------------------------------------

sape.filters[8] = function(row)
{
    var f   = sape.filters;
    var col = row.getElementsByTagName("td");

    var o = col[f.layout.check].getElementsByTagName("input");
    if (o[0].checked) return 0;

    var a = f.wordArray(col[f.layout.text]);

    for (var c=0; c < a.length-1; c++)
    {
         if (f.morf(a[c], a[c+1]))
         {
                f.decorate(row, f.bgcolor);
                o[0].checked = true;

                return 1;
         }
  	}
    return 0;
};

//------------------------------------------------------------------------------
// Контроль пунктуации
//------------------------------------------------------------------------------

sape.filters[11] = function(row)
{
    var f   = sape.filters;
    var col = row.getElementsByTagName("td");

    var o = col[f.layout.check].getElementsByTagName("input");
    if (o[0].checked) return 0;

    var text = f.clearText(col[f.layout.text]);

    if (!text.length) return 0;

    var checkit = false;

    if (f.chkspace && !checkit)
    {
        checkit = (text.length >  text.replace(/^\s+/g, "").replace(/\s+$/g, "").replace(/\s+/g, " ").replace(/\&nbsp\;/g, "").length);
    }
    if (f.chkdot && !checkit)
    {
        checkit = (text.replace(/^\s+/g, "").match(/^[^0-9a-zа-я\"\']+/i) != null);
    }
    if (f.chkcomma && !checkit)
    {
        var m = text.replace(/\.$/g, "").match(/[\.|\,|\!|\?|\:|\;]+/g);
        if (m != null) checkit = (m.length > 3);
    }
    if (checkit)
    {
        f.decorate(row, f.bgcolor);
        o[0].checked = true;

        return 1;
    }
    return 0;
};

//------------------------------------------------------------------------------
// Заявки заглавными буквами
//------------------------------------------------------------------------------

sape.filters[12] = function(row)
{
    var f   = sape.filters;
    var col = row.getElementsByTagName("td");

    var o = col[f.layout.check].getElementsByTagName("input");
    if (o[0].checked) return 0;

    var text = f.clearText(col[f.layout.text]);

    if (text.length && (text.length == text.replace(/[a-zа-яё]+/g, "").length))
    {
        f.decorate(row, f.bgcolor);
        o[0].checked = true;

        return 1;
    }
    return 0;
};

//------------------------------------------------------------------------------
// Регулярка для текста заявки
//------------------------------------------------------------------------------

sape.filters[13] = function(row)
{
    var f   = sape.filters;
    var col = row.getElementsByTagName("td");

    var o = col[f.layout.check].getElementsByTagName("input");
    if (o[0].checked) return 0;

    var text = f.clearText(col[f.layout.text]);

    if (!text.length) return 0;

    var exp = new RegExp(sape.toolbar.utf8.decode(f.regexp), f.regmod);
    try
    {
        if (exp.test(text))
        {
            f.decorate(row, f.bgcolor);
            o[0].checked = true;

            return 1;
        }
    }
    catch (err) {}

    return 0;
};