if (!sape) var sape={};
if (!sape.toolbar) sape.toolbar={};

if (!sape.toolbar.google) sape.toolbar.google =
{
    timeout: 500,
    skip: false,
    icache: true,
    antigate: '',
    stopAPI: false,
    img: "chrome://wmsape/skin/google.png",
    defaultURL:  'http://www.google.ru/search?hl=ru&filter=0&safe=0&pws=0&ie=UTF-8&oe=UTF-8&q=',
    toolbarURL:  'http://toolbarqueries.google.com/tbr?features=Rank&sourceid=navclient-ff&client=navclient-auto-ff&q=',
    webcacheURL: 'http://webcache.googleusercontent.com/search?hl=en&q=',
    apiURL:      'http://www.google.com/uds/GwebSearch?v=1.0&rsz=8&safe=off&hl=ru&gl=www.google.com&source=gsc&q=',
};

sape.toolbar.google.init = function()
{
    var me     = sape.toolbar.google;
    var prefs  = sape.toolbar.prefs();

    me.timeout    = Math.max(100, prefs.getIntPref("timeout.google"));
    me.icache     = prefs.getBoolPref("cache");
    me.skip       = prefs.getBoolPref("re.check");
    me.antigate   = prefs.getCharPref("antigate.api").replace(/(^\s+)|(\s+$)/, '');
    me.stopAPI    = !prefs.getBoolPref("gc.useapi");
    me.seolib     = prefs.getBoolPref("seolib.use");
    me.seobudget  = prefs.getBoolPref("seobudget.use.gl");
    me.domain     = prefs.getCharPref("google.domain").replace(/[^a-z\.]+/, '');
    me.security   = prefs.getBoolPref("google.security");
    me.requestURL = me.defaultURL;

    if (!me.seolib && !me.seobudget)
    {
        if (me.domain == "com") me.requestURL  = 'http://www.google.com/search?hl=en&gl=US';
        if (me.domain == "ru")  me.requestURL  = 'http://www.google.ru/search?hl=ru&gl=RU';
        if (me.domain == "ua")  me.requestURL  = 'http://www.google.com.ua/search?hl=uk&gl=UA';
        if (me.domain == "by")  me.requestURL  = 'http://www.google.by/search?hl=be&gl=BY';
        if (me.domain == "uk")  me.requestURL  = 'http://www.google.co.uk/search?hl=en&gl=GB';
        if (me.domain == "ca")  me.requestURL  = 'http://www.google.ca/search?hl=en&gl=CA';
        if (me.domain == "de")  me.requestURL  = 'http://www.google.de/search?hl=de&gl=DE';
        if (me.domain == "fr")  me.requestURL  = 'http://www.google.fr/search?hl=fr&gl=FR';
        if (me.domain == "it")  me.requestURL  = 'http://www.google.it/search?hl=it&gl=IT';

        if (me.security) me.requestURL = me.requestURL.replace(/^http:/, 'https:');
        me.requestURL =  me.requestURL + '&filter=0&safe=0&pws=0&ie=UTF-8&oe=UTF-8&q=';
    }
    if (me.antigate)  sape.antigate.API = me.antigate;
    if (me.seolib)    sape.seolib.init();
    if (me.seobudget) sape.toolbar.seobudget.init();
};

sape.toolbar.google.stop = function(me)
{
    if (me.inProgress || me.cTimer)
    {
        me.cTimer = 0;
        me.inProgress = 0;

        return true;
    }
    else
        return false;
};

sape.toolbar.google.isCaptcha = function(req)
{
    if (req.status == 403 || req.status == 503) return true;
    if (req.channel.URI.path.indexOf('/sorry/') > -1) return true;
    if (req.channel.URI.host.indexOf('sorry.google') > -1) return true;
    if (req.responseText.indexOf('form action="Captcha"') > -1) return true;
    if (req.responseText.indexOf('Suspected Terms of Service Abuse') > -1) return true;
    if (req.responseText.indexOf('network may be sending automated queries') > -1) return true;
    return false;
};

sape.toolbar.google.cleanup = function()
{
    var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager);
    var cookies = cookieManager.enumerator;
    while (cookies.hasMoreElements())
    {
        var cookie = cookies.getNext().QueryInterface(Components.interfaces.nsICookie);
        if (cookie.host == '.google.com' || cookie.host == 'google.com')
        {
            cookieManager.remove(cookie.host, cookie.name, cookie.path, false);
        }
    }
};

sape.toolbar.google.anticaptcha = function(me, req)
{
    var st = sape.toolbar;
    if (me.inProgress)
    {
        me.inProgress = 0;

        if (st.google.antigate)
        {
            me.cTimer = 1;
            st.showAlert(st.str('ag.wait'), st.str('captcha'), 3, st.google.img);
            sape.antigate.addTask(me, req);
        }
        else
        {
            st.google.cleanup();
            st.showAlert(st.str('ya.stop'), st.str('captcha'), 2, st.google.img);
        }
    }
};

sape.toolbar.google.next = function(me)
{
      var st = sape.toolbar;
      var timeout = (arguments.length > 1)? arguments[1] : st.google.timeout + Math.round(st.google.timeout * Math.random());

      if (me.inProgress) st.setTimer(me.nextone, timeout);
};

sape.toolbar.google.placeCounter = function(place, count)
{
    var b = place.ownerDocument.createElement('b');
        b.className = 'not-blocked-in-google';
        b.appendChild(place.ownerDocument.createTextNode('G:'));

    var s = place.ownerDocument.createTextNode(" [" + count + "]\xA0");
    var sp = place.ownerDocument.createTextNode(" ");

    var e = place.getElementsByTagName('b');
    for (var i=0; i < e.length; i++)
    {
        if (e[i].className == 'blocked-in-google')
        {
            e[i].className = 'not-blocked-in-google';
            e[i].textContent = 'G:';
            e[i].parentNode.insertBefore(s, e[i].nextSibling);
            return;
        }
        if (e[i].className == 'not-blocked-in-google')
        {
            e[i].nextSibling.textContent = " [" + count + "]\xA0";
            return;
        }
    }
    place.appendChild(sp);
    place.appendChild(b);
    place.appendChild(s);
};

//------------------------------------------------------------------------------
// Поиск ссылки в выдаче
//------------------------------------------------------------------------------

sape.toolbar.google.inIndex = function(link, text)
{
    function parseIE(searchText)
    {
        var s, result = new Array();
        var exp = /a href=[\"]?([^\"]+)[\"]?\s[^>]+>([^<]*)</g;
            exp.lastIndex = 0;

        while (s = exp.exec(searchText))
        {
            if (sape.toolbar.urlCheck(s[1]))
            {
                var e = {};
                    e.url = sape.toolbar.getURL(s[1]);
                    e.titleNoFormatting = s[2].toString();

                result.push(e);
            }
        }
        return result;
    };

    function clean(link)
    {
        return link.toLowerCase()
                   .replace(/^[^\/]+[\/]+/i, '')
                   .replace(/^www\./i, '')
                   .replace(/\&amp\;/g, '&')
                   .replace(/\/$/, '');
    };

    try
    {
        var res = parseIE(text);
        var myLink = sape.toolbar.getURL(link);
        for (var i=0; i < res.length; i++)
        {
            if (clean(res[i].url) == clean(myLink)) return res[i];
        }
    } catch(e){}
    return 0;
};

//------------------------------------------------------------------------------
// Поиск ссылки в результатах API
//------------------------------------------------------------------------------

sape.toolbar.google.inIndexAPI = function(link, text)
{
    function clean(link)
    {
        return link.toLowerCase()
                   .replace(/^[^\/]+[\/]+/i, '')
                   .replace(/^www\./i, '')
                   .replace(/\&amp\;/g, '&')
                   .replace(/\/$/, '');
    };

    var st  = sape.toolbar;
    var myLink = st.getURL(link);

    if (text.indexOf('results') > -1)
    {
        try
        {
            var obj = st.parseJSON(text);
            if (obj && typeof(obj.responseData.results) == 'object')
            {
                var res = obj.responseData.results;
                for (var i=0; i < res.length; i++)
                {
                    if (clean(st.getURL(res[i].url)) == clean(myLink))
                    {
                        if (st.google.icache && res[i].cacheUrl.length) st.cache.push(st.google.gc.query(link, 2), 'gc', res[i].cacheUrl);
                        return res[i];
                    }
                }
            }
        } catch(e){}
    }
    return 0;
};

sape.toolbar.google.countIndex = function(text)
{
    if (text.indexOf('Your search') > -1 && text.indexOf('did not match any documents') > -1) return 0; // en
    if (text.indexOf('По запросу') > -1 && text.indexOf('ничего не найдено') > -1)            return 0; // ru
    if (text.indexOf('На запит') > -1 && text.indexOf('не знайдено жодного документа') > -1)  return 0; // uk
    if (text.indexOf('Па Вашым запыце') > -1 && text.indexOf('ніводнага дакумэнта') > -1)     return 0; // be
    if (text.indexOf('Aucun document ne correspond aux termes de recherche') > -1)            return 0; // fr
    if (text.indexOf('Es wurden keine mit') > -1 && text.indexOf('Dokumente gefunden') > -1)  return 0; // de
    if (text.indexOf('La ricerca di') > -1 && text.indexOf('non ha prodotto risultati') > -1) return 0; // it

    var res, exp = /id\=resultStats([^<]+)<nobr/i;
    if (res = exp.exec(text))
    {
        var txt = res[1].replace(/&#\d+;/g, '').replace(/[^\d]+/g, '');
        return parseInt(txt, 10);
    }
    else return -1;
};

//------------------------------------------------------------------------------
// Проверка индексации сайта
//------------------------------------------------------------------------------
if (!sape.toolbar.google.gs) sape.toolbar.google.gs =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    lay: {},
    idx: 0,
    counter: 0,
    cTimer: 0,
};

sape.toolbar.google.gs.unload = function()
{
    var me = sape.toolbar.google.gs;

    me.cTimer = 0;
    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.toolbar.google.gs.query = function(link, place, row)
{
    var st = sape.toolbar, google = st.google, me = google.gs;

    var wait  = google.timeout + Math.round(google.timeout * Math.random());
    var host  = link.split('/')[2].replace(/^www./, '');
    var lhost = 'http://' + host + '/';
    var q     = "site:" + host;
    var url   = google.requestURL + st.urlEncode(q);

    var req = new XMLHttpRequest();
        req.open('GET', url, true);

    var requestTimer = st.reqTimer(req, 15000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            requestTimer.cancel();
            if (google.isCaptcha(req))
            {
                if (!me.cTimer) google.anticaptcha(me, req);
                row.removeAttribute('gs');
                return;
            }
            if (req.status == 200 && req.responseText.length)
            {
                    var gcount = google.countIndex(req.responseText);
                    if (gcount > -1)
                    {
                        var col = row.getElementsByTagName('td');

                        if (me.showcounters) st.google.placeCounter(col[me.lc], gcount);
                        if (st.google.icache) st.cache.push(lhost, 'gs', gcount);

                        if (gcount > 0) place.setAttribute("style", "color:white !important; background-color:green !important;");
                        else
                        {
                            place.setAttribute("style", "color:white !important; background-color:red !important;");

                            var box = col[me.lay.check].getElementsByTagName('input');
                            if (box && !box[0].checked)
                            {
                                box[0].checked = true;
                                me.counter++;
                            }
                        }
                    }
                    else
                    {
                        place.setAttribute("style", "color:white !important; background-color:silver !important;");
                    }
                    return st.google.next(me, wait);
            }
            else
            {
                place.setAttribute("style", "color:white !important; background-color:silver !important;");
                return st.google.next(me, wait);
            }
        }
    }
    req.send(null);
};

sape.toolbar.google.gs.nextone = function()
{
    var st = sape.toolbar, me = st.google.gs;
    if (!me.inProgress || !me.doc) return;

    var row = me.doc.getElementsByTagName('tr');
    if (me.doc.defaultView) for (var i=0; i < row.length; i++)
    {
        if (row[i].getAttribute('gs') == '1') continue;
        if (row[i].innerHTML.indexOf('icon_gc icon_gs') == -1) continue;

        var col   = row[i].getElementsByTagName('td');
        var box   = col[me.lay.check].getElementsByTagName('input');
        var a     = col[me.lc].getElementsByTagName('a');
        var link  = st.getURL(a[me.idx].getAttribute('href'));
        var host  = link.split('/')[2].replace(/^www./i,'');

        if (st.google.skip && box[0].checked) continue;

        var ai = col[me.lay.ico].getElementsByTagName('a'), as = 0;
        for (var j=0; j< ai.length; j++)
        {
            if (ai[j].className == 'icon_gc icon_gs')
            {
              as = ai[j];
              break;
            }
        }
        if (as)
        {
            row[i].setAttribute('gs', '1');
            var gcount = (st.google.icache)? st.cache.pop('http://' + host + '/', 'gs') : null;
            if (gcount !== null)
            {
                if (gcount > 0) as.setAttribute("style", "color:white !important; background-color:green !important;");
                else
                {
                    place.setAttribute("style", "color:white !important; background-color:red !important;");
                    if (box && !box[0].checked)
                    {
                        box[0].checked = true;
                        me.counter++;
                    }
                }
                if (me.showcounters) st.google.placeCounter(col[me.lc], gcount);
                continue;
            }
            var cbox = box[0];
            if (st.google.seobudget) return st.seobudget.gs(link, as, cbox, row[i]);

            return me.query(link, as, row[i]);
        }
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('gs.finish'), 2, st.google.img);
    }
};

sape.toolbar.google.gs.start = function()
{
    var st = sape.toolbar, google = st.google, me = google.gs;
    if (google.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('gs.stop'), 2, st.google.img);
        return;
    }
    if (me.doc) me.unload();

    var doc = content.document;
    if (!st.inside(doc)) return;

    var prefs = st.prefs();
    var lay   = st.layout(doc);

    google.init();
    me.showcounters = (lay.black)? false : prefs.getBoolPref("showcounters.google");

    me.lay         = lay;
    me.lc          = (lay.url < 0)? lay.link : lay.url;
    me.idx         = lay.idx;
    me.doc         = doc;
    me.counter     = 0;

    me.doc.defaultView.addEventListener('unload', me.unload, false);

    if (me.lc == -1) return;

    // Расставляем кнопки
    var row  = doc.getElementsByTagName('tr');

    for (var i = 0; i < row.length; i++)
    {
        if (row[i].hasAttribute('gs')) continue;

        var col = row[i].getElementsByTagName('td');
        if (col.length < me.lay.cols) continue;

        var box = col[me.lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;
        if (!st.boxCheck(box[0])) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.idx + 1) continue;

        var href = a[me.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var link = st.getURL(href);
        var host = link.split('/')[2].replace(/^www./i,'');
        var q    = "site:" + host;
        var url  = google.requestURL + st.urlEncode(q);

        var as = me.doc.createElement('a');
            as.href = url;
            as.target = '_blank';
            as.className = 'icon_gc icon_gs';
            as.appendChild(me.doc.createTextNode('GS'));

        var ai = col[me.lay.ico].getElementsByTagName('a'), ico = null, place = as;
        for (var j=0; j < ai.length; j++)
        {
            if (ai[j].className.match(/icon_/)) ico = ai[j];
            if (ai[j].className == 'icon_gc icon_gs') break;
        }

        if (ico)
        {
            if (ico.className == 'icon_gc icon_gs')
            {
                place = ico;
                place.href = url;
                place.textContent = 'GS';
                place.style.color = '';
                place.style.backgroundColor = '';
            }
            else
            {
                if (me.lay.ico == me.lc && j < me.idx) return;
                ico.parentNode.insertBefore(as, ico.nextSibling);
            }
        }
        else
        {
            var div = me.doc.createElement('div');
            div.style.marginTop = "2px";
            div.style.marginBottom = "4px";

            div.appendChild(as);
            col[me.lay.ico].appendChild(div);
        }

        var gcount = (google.icache)? st.cache.pop('http://' + host + '/', 'gs') : null;
        if (gcount !== null)
        {
            if (gcount > 0) place.setAttribute("style", "color:white !important; background-color:green !important;");
            else
            {
                place.setAttribute("style", "color:white !important; background-color:red !important;");
                if (box && !box[0].checked)
                {
                    box[0].checked = true;
                    me.counter++;
                }
            }
            if (me.showcounters) google.placeCounter(col[me.lc], gcount);
            row[i].setAttribute('gs', '1');
        }
        col[me.lc].className = col[me.lc].className.replace('a_visited', '');
    }

    st.showAlert(st.str('nice'), st.str('gs.start'), 1, st.google.img);
    me.inProgress = 1;

    var streams = (st.google.seobudget)? 3: 1;
    for (var i=0; i < streams; i++) google.next(me, 500 * (i+1));
};

//------------------------------------------------------------------------------
// Проверка индексации ссылок
//------------------------------------------------------------------------------

if (!sape.toolbar.google.gl) sape.toolbar.google.gl =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    tc: -1,
    dc: 0,
    lay: {},
    idx: 0,
    liveDays: 0,
    lastDate: 0,
    counter: 0,
    cTimer: 0,
};

sape.toolbar.google.gl.gettext = function(cell)
{
    var st = sape.toolbar, doc = cell.ownerDocument, result = "", parts = [], wcount = 0;
    var s = cell.getElementsByTagName('span');

    if (s.length && st.sape(doc))
    {
        for (var i=0; i< s.length; i++) if (s[i].className.match(/txt_container|link_text/)) cell = s[i];
    }

    var text = cell.innerHTML.replace(/<br.*$/, "").replace(/[\r\n\f]*/, "").replace(/<p.*$/, "");

    if (st.sape(doc))     parts = text.split(/<\/?u[^>]*>/);

    while (parts.length)
    {
        text = parts.shift();
        text = text.replace(/<(a|span)[^<]+<\/(a|span)>/g, '')
                   .replace(/^[\*\s]*/g, "")
                   .replace(/<div.*$/, "")
                   .replace(/<[^<>]+>/g, "");

        text = st.html2text(text, doc);
        text = text.replace(/[\"\']+/g, " ")
                   .replace(/(\s{2,})/g, " ")
                   .replace(/^[^0-9a-zа-яё]+/i, "")
                   .replace(/(^\s+)|(\s+$)/g, "")
                   .replace(/[\%\+]+/g, '" "');

        wcount += text.split(/\s+/).length;
        if (text.length > 2) result += '"' + text + '" ';
    }
    return result;
};

sape.toolbar.google.gl.query = function(link, text)
{
    return text + 'site:' + link.split('/')[2].replace(/^www\./i, '');
};

sape.toolbar.google.gl.site = function(link, place, row, step)
{
    var st = sape.toolbar, google = st.google, me = google.gl;
    var wait = google.timeout + Math.round(google.timeout * Math.random());
    row.setAttribute('gl', '1');

    var col  = row.getElementsByTagName('td');
    var q    = me.query(link, me.gettext(col[me.tc]));
    var qs   = google.gc.query(link, 1);

    var cache = (google.icache)? st.cache.pop(q, 'gc') : null;
    if (cache !== null)
    {
            if (cache == 404)
            {
                place.setAttribute("style", "color:white !important; background-color:red !important;");
                col[me.lay.check].getElementsByTagName('input')[0].checked = true;
            }
            if (cache.match(/^http/))
            {
                place.setAttribute("style", "color:white !important; background-color:green !important;");
                place.href = cache;
            }
            return me.nextone();
    }
    if (st.google.stopAPI) step = 1;
    if (step == 0)
    {
        var url = google.apiURL + st.urlEncode(q);

        var req = new XMLHttpRequest();
            req.open('GET', url, true);
            req.setRequestHeader('Referer', me.lay.loc);

        var requestTimer = st.reqTimer(req, 15000);

        req.onreadystatechange = function (aEvt)
        {
            if (req.readyState == 4)
            {
                requestTimer.cancel();
                if (google.isCaptcha(req))
                {
                    google.stopAPI = true;
                    me.site(link, place, row, 1);
                    return;
                }
                if (req.status == 200 && req.responseText.length)
                {
                    var result = google.inIndexAPI(link, req.responseText);
                    if (result)
                    {
                        place.setAttribute("style", "color:white !important; background-color:green !important;");
                        place.href = google.requestURL + st.urlEncode(q);
                        place.title = result.titleNoFormatting;
                        if (google.icache)
                        {
                            st.cache.push(q,  'gc', google.requestURL + st.urlEncode(q));
                            st.cache.push(qs, 'gc', google.requestURL + st.urlEncode(qs));
                        }
                        return google.next(me, 500);
                    }
                }
                me.site(link, place, row, 1);
            }
        }
        req.send(null);
    }
    if (step == 1)
    {
        var url = google.requestURL + st.urlEncode(q) + '&num=100';
        var req = new XMLHttpRequest();
            req.open('GET', url, true);

        var requestTimer = st.reqTimer(req, 15000);

        req.onreadystatechange = function (aEvt)
        {
            if (req.readyState == 4)
            {
                requestTimer.cancel();
                if (google.isCaptcha(req))
                {
                    if (!me.cTimer) google.anticaptcha(me, req);
                    row.removeAttribute('gl');
                    return;
                }
                if (req.status == 200 && req.responseText.length)
                {
                    var result = google.inIndex(link, req.responseText);
                    if (result)
                    {
                        place.setAttribute("style", "color:white !important; background-color:green !important;");
                        place.href = google.requestURL + st.urlEncode(q) + '&num=100';;
                        place.title = result.titleNoFormatting;
                        if (google.icache)
                        {
                            st.cache.push(q,  'gc', google.requestURL + st.urlEncode(q));
                            st.cache.push(qs, 'gc', google.requestURL + st.urlEncode(qs));
                        }
                    }
                    else
                    {
                        place.setAttribute("style", "color:white !important; background-color:red !important;");
                        var box = col[me.lay.check].getElementsByTagName('input');
                        if (box && !box[0].checked)
                        {
                            box[0].checked = true;
                            me.counter++;
                        }
                        if (google.icache) st.cache.push(q, 'gc', 404);
                    }
                }
                google.next(me);
            }
        }
        req.send(null);
    }
};

sape.toolbar.google.gl.nextone = function()
{
    var st = sape.toolbar, me = st.google.gl;
    if (!me.inProgress || !me.doc) return;

    var row = me.doc.getElementsByTagName('tr');
    if (me.doc.defaultView) for (var i=0; i < row.length; i++)
    {
        if (row[i].getAttribute('gl') == '1') continue;
        if (row[i].innerHTML.indexOf('icon_gl icon_gc') == -1) continue;

        var col   = row[i].getElementsByTagName('td');
        var box   = col[me.lay.check].getElementsByTagName('input');
        var a     = col[me.lc].getElementsByTagName('a');
        var link  = st.getURL(a[me.idx].getAttribute('href'));

        if (st.google.skip && box[0].checked) continue;

        var ai = col[me.lay.ico].getElementsByTagName('a'), place = 0;
        for (var j=0; j< ai.length; j++)
        {
            if (ai[j].className == 'icon_gl icon_gc')
            {
              place = ai[j];
              break;
            }
        }
        if (place)
        {
            var myLink = st.getMyLink(me, row[i]);
            if (myLink && (st.google.seolib || st.google.seobudget))
            {
                if (st.google.seobudget) return st.seobudget.gl(link, st.ya.yal.gettext(col[me.tc]), myLink, place, row[i]);
                if (st.google.seolib)    return sape.seolib.gl(link, myLink, place, row[i]);
            }
            else return me.site(link,  place, row[i], 0);
        }
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('gl.finish'), 2, st.google.img);
    }
};

sape.toolbar.google.gl.unload = function()
{
    var me = sape.toolbar.google.gl;

    me.cTimer = 0;
    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.toolbar.google.gl.start = function()
{
    var st = sape.toolbar, google = st.google, me = google.gl;
    if (google.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('gl.stop'), 2, st.google.img);
        return
    }
    if (me.doc) me.unload();

    var doc = content.document;
    if (!st.inside(doc)) return;

    var prefs = st.prefs();
    var lay   = st.layout(doc);

    if (lay.dc == -1) return;

    google.init();

    me.liveDays    = prefs.getIntPref("livedays");
    me.lastDate    = new Date();

    me.lastDate.setDate(me.lastDate.getDate() - me.liveDays);

    me.lay = lay;
    me.doc = doc;
    me.idx = lay.idx;
    me.dc  = lay.dc;
    me.tc  = lay.text;
    me.lc  = (lay.link < 0)? lay.url : lay.link;
    me.counter = 0;

    me.doc.defaultView.addEventListener('unload', me.unload, false);

    if (me.lc == -1) return;

    // Расставляем кнопки
    var row  = doc.getElementsByTagName('tr');

    for (var i=0; i < row.length; i++)
    {
        if (row[i].getAttribute('gl') == '1') continue;
        if (row[i].innerHTML.indexOf('icon_gl icon_gc') != -1) continue;

        var col = row[i].getElementsByTagName('td');
        if (col.length < me.lay.cols) continue;

        if (col[me.tc].innerHTML.indexOf('"Context"') > -1) continue;

        var box = col[me.lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;

        if (google.skip && box[0].checked) continue;

        if (me.liveDays > 0)
        {
            var dateText = '';
            if (dateText = col[me.dc].innerHTML.match(/([0-9]+)\.([0-9]+)\.([0-9]+)/))
            if (dateText.length > 3)
            {
                var dd = parseInt(dateText[1], 10);
                var mm = parseInt(dateText[2], 10)-1;
                var yy = parseInt(dateText[3], 10);
                if (yy < 2000) yy += 2000;

                var linkDate = new Date(yy,mm,dd);
                if (linkDate > me.lastDate) continue;
            }
        }
        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.idx + 1) continue;

        var href = a[me.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var link = st.getURL(href);
        var text = me.gettext(col[me.tc]);
        var q    = me.query(link, text);
        var url  = google.requestURL + encodeURIComponent(q)  + '&num=100';

        var as = me.doc.createElement('a');
            as.href = url;
            as.target = '_blank';
            as.className = 'icon_gl icon_gc';
            as.appendChild(me.doc.createTextNode('GL'));

        var ai = col[me.lay.ico].getElementsByTagName('a'), ico = 0;
        for (var j=0; j < ai.length; j++)
        {
          if (ai[j].className.match(/icon_/)) ico = ai[j];
          if (ai[j].className == 'icon_gc') break;
        }

        if (ico)
        {
            if (me.lay.ico == me.lc && j < me.idx) return;
            ico.parentNode.insertBefore(as, ico.nextSibling);
        }
        else
        {
            var div = me.doc.createElement('div');
            div.style.marginTop = "2px";
            div.style.marginBottom = "4px";

            div.appendChild(as);
            col[me.lay.ico].appendChild(div);
        }

        var cache = (google.icache)? st.cache.pop(q, 'gc') : null;
        if (cache != null)
        {
            if (cache == 404)
            {
                as.setAttribute("style", "color:white !important; background-color:red !important;");
                if (box && !box[0].checked)
                {
                    box[0].checked = true;
                    me.counter++;
                }
            }
            if (cache.match(/^http/))
            {
                as.setAttribute("style", "color:white !important; background-color:green !important;");
                as.href = cache;
            }
            row[i].getAttribute('gl', '1');
        }
        col[me.lc].className = col[me.lc].className.replace('a_visited', '');
    }

    st.showAlert(st.str('nice'), st.str('gl.start'), 1, st.google.img);
    me.inProgress = 1;

    var streams = (st.google.seolib || st.google.seobudget)? 3: 1;
    for (var i=0; i < streams; i++) google.next(me, 500 * (i+1));
};

//------------------------------------------------------------------------------
// Проверка индексации страниц
//------------------------------------------------------------------------------

if (!sape.toolbar.google.gc) sape.toolbar.google.gc =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    lay: {},
    idx: 0,
    ctype: 2,
    nodeName: 'GC',
    counter: 0,
    cTimer: 0,
};

sape.toolbar.google.gc.query = function(link, ctype)
{
    if (ctype) return 'cache:' + link.replace(/^[^\/]+[\/]+/i, '');
    else       return 'info:'  + link.replace(/^[^\/]+[\/]+/i, '');
};

//------------------------------------------------------------------------------
// Проверка info через API. step = 0 без www, step = 1 с www,
//------------------------------------------------------------------------------

sape.toolbar.google.gc.ainfo = function(link, place, row, step)
{
    var st = sape.toolbar, me = st.google.gc;
    row.setAttribute('gc.0', '1');

    if (st.google.stopAPI) return me.info(link, place, row, 0);

    var lnk = link.replace(/\/\/www\./i, '//');
    if (step) lnk = lnk.replace('//', '//www.');

    var q   = me.query(lnk, 0);
    var cl  = me.query(link, 0);

    var url = st.google.apiURL + st.urlEncode(q);

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.setRequestHeader('Referer', me.lay.loc);

    var requestTimer = st.reqTimer(req, 15000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            requestTimer.cancel();
            if (st.google.isCaptcha(req))
            {
                st.google.stopAPI = true;
                return me.info(link, place, row, 0);
            }
            if (req.status == 200 && req.responseText.length)
            {
                var result = st.google.inIndexAPI(lnk, req.responseText);
                if (result)
                {
                        place.setAttribute("style", "color:white !important; background-color:green !important;");
                        place.href = st.google.requestURL + st.urlEncode(q);
                        place.title = result.titleNoFormatting;

                        if (st.google.icache) st.cache.push(cl, 'gc', place.href);
                        return st.google.next(me, 500);
                }
            }
            if (step) return me.info(link, place, row, 0);
            else      return me.ainfo(link, place, row, 1);
        }
    }
    try {req.send(null)} catch(e) {req.abort()}
};

//------------------------------------------------------------------------------
// Проверка info через выдачу. step = 0 без www, step = 1 с www,
//------------------------------------------------------------------------------

sape.toolbar.google.gc.info = function(link, place, row, step)
{
    var st = sape.toolbar, me = st.google.gc;
    row.setAttribute('gc.0', '1');

    var lnk = link.replace(/\/\/www\./i, '//');
    if (step) lnk = lnk.replace('//', '//www.');

    var q   = me.query(lnk, 0);
    var cl  = me.query(link, 0);
    var url = st.google.requestURL + st.urlEncode(q);

    var req = new XMLHttpRequest();
        req.open('GET', url, true);

    var requestTimer = st.reqTimer(req, 15000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            requestTimer.cancel();
            if (st.google.isCaptcha(req))
            {
                if (!me.cTimer) st.google.anticaptcha(me, req);
                row.removeAttribute('gc.0');
                return;
            }
            if (req.status == 200 && req.responseText.length)
            {
                var result = st.google.inIndex(lnk, req.responseText);
                if (result)
                {
                    place.setAttribute("style", "color:white !important; background-color:green !important;");
                    place.href = st.google.requestURL + st.urlEncode(q);
                    place.title = result.titleNoFormatting;

                    if (st.google.icache) st.cache.push(cl, 'gc', place.href);
                    return st.google.next(me);
                }
                else
                {
                    if (!step) return me.info(link, place, row, 1);
                    else
                    {
                        place.setAttribute("style", "color:white !important; background-color:red !important;");

                        var col = row.getElementsByTagName('td');
                        var box = col[me.lay.check].getElementsByTagName('input');
                        if (box && !box[0].checked)
                        {
                            box[0].checked = true;
                            me.counter++;
                        }
                        if (st.google.icache) st.cache.push(cl, 'gc', 404);
                        return st.google.next(me);
                    }
                }
            }
            else
            {
                if (!step) return me.info(link, place, row, 1);
                else
                {
                    place.setAttribute("style", "color:white !important; background-color:silver !important;");
                    return st.google.next(me);
                }
            }
        }
    }
    try {req.send(null)} catch(e) {req.abort()}
};

//------------------------------------------------------------------------------
// Проверка cache через API. step = 0 без www, step = 1 с www,
//------------------------------------------------------------------------------

sape.toolbar.google.gc.acache = function(link, place, row, step)
{
    var st = sape.toolbar, me = st.google.gc;
    row.setAttribute('gc.2', '1');

    if (st.google.stopAPI) return me.cache(link, place, row, 0);

    var lnk = link.replace(/\/\/www\./i, '//');
    if (step) lnk = lnk.replace('//', '//www.');

    var q   = me.query(lnk, 0);
    var cl  = me.query(link, 2);

    var url = st.google.apiURL + st.urlEncode(q);

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.setRequestHeader('Referer', me.lay.loc);

    var requestTimer = st.reqTimer(req, 15000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            requestTimer.cancel();
            if (st.google.isCaptcha(req))
            {
                st.google.stopAPI = true;
                return me.cache(link, place, row, 0);
            }
            if (req.status == 200 && req.responseText.length)
            {
                var result = st.google.inIndexAPI(lnk, req.responseText);
                if (result && result.cacheUrl.length)
                {
                        place.setAttribute("style", "color:white !important; background-color:green !important;");
                        place.href = result.cacheUrl;
                        place.title = result.titleNoFormatting;

                        if (st.google.icache) st.cache.push(cl, 'gc', place.href);
                        return st.google.next(me, 500);
                }
            }
            if (step) return me.cache(link, place, row, 0);
            else      return me.acache(link, place, row, 1);
        }
    }
    try {req.send(null)} catch(e) {req.abort()}
};

sape.toolbar.google.gc.placeDate = function(place, count)
{
    var b = place.ownerDocument.createElement('b');
        b.className = 'not-blocked-in-google gc';
        b.appendChild(place.ownerDocument.createTextNode('GC:'));
        b.title = sape.toolbar.str('yac.date');

    var s = place.ownerDocument.createTextNode("\xA0[" + count + "]\xA0");
    var sp = place.ownerDocument.createTextNode(" ");

    place.appendChild(sp);
    place.appendChild(b);
    place.appendChild(s);
};

sape.toolbar.google.gc.getDate = function(text)
{
    var fz = function(n) {return "" + ((n > 9)? n : "0" + n)};

    var res = /appeared\s*on\s*([^<]*GMT)/.exec(text);
    if (!res) return null;

    var pageDate = new Date(res[1]);
    var strDate  = fz(pageDate.getDate()) + '.' + fz(pageDate.getMonth() + 1) + '.' + pageDate.getFullYear();
    return strDate;
};

//------------------------------------------------------------------------------
// Проверка cache через выдачу. step = 0 без www, step = 1 с www,
//------------------------------------------------------------------------------

sape.toolbar.google.gc.cache = function(link, place, row, step)
{
    var st = sape.toolbar, me = st.google.gc;
    row.setAttribute('gc.2', '1');

    var lnk = link.replace(/\/\/www\./i, '//');
    if (step) lnk = lnk.replace('//', '//www.');

    var q   = me.query(lnk, 2);
    var cl  = me.query(link, 2);
    var url = st.google.webcacheURL + st.urlEncode(q).replace("cache%3A", "cache:") + '&strip=1';
    var col = row.getElementsByTagName('td');

    var myLink = st.getMyLink(me, row);

    var req = new XMLHttpRequest();
        req.open('GET', url, true);

    var requestTimer = st.reqTimer(req, 15000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            requestTimer.cancel();
            if (st.google.isCaptcha(req))
            {
                if (!me.cTimer) st.google.anticaptcha(me, req);
                row.removeAttribute('gc.2');
                return;
            }
            if ((req.status == 200 && req.responseText.length) || req.status == 404)
            {
                if (req.responseText.indexOf('It is a snapshot of the page as it appeared') > 0)
                {
                    place.setAttribute("style", "color:white !important; background-color:green !important;");
                    place.href = st.google.webcacheURL + st.urlEncode(q).replace("cache%3A", "cache:");

                    if (me.checkCacheDate)
                    {
                        var strDate = me.getDate(req.responseText);
                        if (strDate)
                        {
                            me.placeDate(col[me.lay.ico], strDate);
                            if (st.google.icache) st.cache.push(cl, 'gcd', strDate);
                        }
                    }
                    if (me.checkMyLink && myLink)
                    {
                        var srch = 'a href="' + myLink.replace(/&.*$/i, '').replace(/\/$/i, '');
                        var data = st.ext.utClean(req.responseText, 0);
                        if (data.indexOf(srch) > -1)
                        {
                            place.textContent = "GC+";
                            place.title = st.str('ext.found');
                            if (st.google.icache) st.cache.push(cl + '++' + myLink,  'gc', 200);
                        }
                    }
                    if (st.google.icache) st.cache.push(cl, 'gc', place.href);

                    return st.google.next(me);
                }
                if ((req.responseText.indexOf('Try more general keywords') > 0) || (req.status == 404))
                {
                    if (!step) return me.cache(link, place, row, 1);
                    else
                    {
                        place.setAttribute("style", "color:white !important; background-color:red !important;");

                        var box = col[me.lay.check].getElementsByTagName('input');
                        if (box && !box[0].checked)
                        {
                            box[0].checked = true;
                            me.counter++;
                        }
                        if (st.google.icache) st.cache.push(cl, 'gc', 404);
                        return st.google.next(me);
                    }
                }
            }
            if (!step) return me.cache(link, place, row, 1);
            else
            {
                place.setAttribute("style", "color:white !important; background-color:silver !important;");
                return st.google.next(me);
            }
        }
    }
    try {req.send(null)} catch(e) {req.abort()}
};


sape.toolbar.google.gc.nextone = function()
{
    var st = sape.toolbar, google = st.google, me = google.gc;
    if (!me.inProgress || !me.doc) return;

    var row = me.doc.getElementsByTagName('tr');

    for (var i=0; i < row.length; i++)
    {
        if (row[i].getAttribute('gc.' + me.ctype) == '1') continue;

        var col = row[i].getElementsByTagName('td');
        if (col.length < me.lay.cols) continue;

        var box = col[me.lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;
        if (!st.boxCheck(box[0])) continue;

        if (google.skip && box[0].checked) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.idx + 1) continue;

        var href = a[me.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var link  = st.getURL(href);

        var ai = col[me.lay.ico].getElementsByTagName('a'), place = 0;
        for (var j=0; j < ai.length; j++)
        {
            if (ai[j].className == 'icon_gc')
            {
              place = ai[j];
              break;
            }
        }
        if (place)
        {
            var cl  = me.query(link, me.ctype);
            var cache = (google.icache)? st.cache.pop(cl, 'gc') : null;

            if (cache != null)
            {
                if (cache == 404)
                {
                    place.setAttribute("style", "color:white !important; background-color:red !important;");
                    var box = col[me.lay.check].getElementsByTagName('input');
                    if (box && !box[0].checked)
                    {
                        box[0].checked = true;
                        me.counter++;
                    }
                }
                if (cache.match(/^http/))
                {
                    if (me.checkMyLink)
                    {
                        var myLink = st.getMyLink(me, row);
                        if (myLink && (st.cache.pop(cl + '++' + myLink,  'gc') == 200))
                        {
                            place.textContent = "GC+";
                            place.title = st.str('ext.found');
                        }
                    }
                    if (me.checkCacheDate)
                    {
                        var cachedate = st.cache.pop(cl, 'gcd');
                        if (cachedate) me.placeDate(col[me.lay.ico], cachedate);
                    }
                    place.setAttribute("style", "color:white !important; background-color:green !important;");
                    place.href = cache;
                }
                row[i].setAttribute('gc.' + me.ctype, '1');
                continue;
            }
            try
            {
                if (row[i].hasAttribute('gc.' + me.ctype)) continue;

                if (st.google.seolib)    return sape.seolib.cache(link, place, row[i]);
                if (st.google.seobudget) return st.seobudget.cache(link, place, row[i]);

                if (!me.ctype)    return me.ainfo(link,  place, row[i], 0);
                else              return me.acache(link, place, row[i], 0);
            }
            catch(e){}
        }
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('gc.finish'), 2, st.google.img);
    }
};

sape.toolbar.google.gc.unload = function()
{
    var me = sape.toolbar.google.gc;

    me.cTimer = 0;
    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.toolbar.google.gc.start = function()
{
    var st = sape.toolbar, google = st.google, me = google.gc;
    if (google.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('gc.stop'), 2, st.google.img);
        return;
    }
    if (me.doc) me.unload();

    var doc = content.document;
    if (!st.inside(doc)) return;

    var prefs = st.prefs();
    var lay   = st.layout(doc);

    google.init();

    me.ctype       = prefs.getIntPref("googlecheck")? 2 : 0;
    me.lay         = lay;
    me.lc          = (lay.url < 0)? lay.link : lay.url;
    me.idx         = lay.idx;
    me.doc         = doc;
    me.counter     = 0;

    me.doc.defaultView.addEventListener('unload', me.unload, false);

    if (me.lc == -1) return;
    if (me.lay.loc.indexOf('sape.ru/site_pages.php') > 0 || me.lay.loc.indexOf('/site_pages_context.php') > 0) me.lay.ico = 0;

    if (st.google.seolib || st.google.seobudget) me.ctype = 2;

    if (me.ctype) me.nodeName = 'GC';
    else          me.nodeName = 'GI';

    me.checkMyLink    = (me.ctype && !st.google.seolib && !st.google.seobudget && google.stopAPI);
    me.checkCacheDate = (me.ctype && (st.google.seobudget || st.google.seolib || google.stopAPI));

    // Расставляем кнопки
    var row  = doc.getElementsByTagName('tr');

    for (var i = 0; i < row.length; i++)
    {
        if (row[i].getAttribute('gc.' + me.ctype) == '1') continue;

        var col = row[i].getElementsByTagName('td');
        if (col.length < me.lay.cols) continue;

        var box = col[me.lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;
        if (!st.boxCheck(box[0])) continue;

        if (google.skip && box[0].checked) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.idx + 1) continue;

        var href = a[me.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var link = st.getURL(href), url = '';
        var q    = me.query(link, me.ctype);

        if (me.ctype) url = google.webcacheURL + st.urlEncode(q).replace("cache%3A", "cache:");
        else          url = google.requestURL + st.urlEncode(q);

        var as = me.doc.createElement('a');
            as.href = url;
            as.target = '_blank';
            as.className = 'icon_gc';
            as.appendChild(me.doc.createTextNode(me.nodeName));

        var ai = col[me.lay.ico].getElementsByTagName('a'), ico = null, place = as;
        for (var j=0; j < ai.length; j++)
        {
            if (ai[j].className.match(/icon_/))   ico = ai[j];
            if (ai[j].className.match(/icon_gc/)) break;
        }

        if (ico)
        {
            if (ico.className == 'icon_gc')
            {
                place = ico;
                place.href = url;
                place.textContent = me.nodeName;
                place.style.color = '';
                place.style.backgroundColor = '';
                place.removeAttribute('onclick');
            }
            else
            {
                if (me.lay.ico == me.lc && j < me.idx) return;
                ico.parentNode.insertBefore(as, ico.nextSibling);
            }
        }
        else
        {
            var div = me.doc.createElement('div');
            div.style.marginTop = "2px";
            div.style.marginBottom = "4px";

            div.appendChild(as);
            col[me.lay.ico].appendChild(div);
        }

        var cache = (google.icache)? st.cache.pop(q, 'gc') : null;
        if (cache != null)
        {
            if (cache == 404)
            {
                place.setAttribute("style", "color:white !important; background-color:red !important;");
                place.href = url;
                if (box && !box[0].checked)
                {
                    box[0].checked = true;
                    me.counter++;
                }
            }
            if (cache.match(/^http/))
            {
                if (me.checkMyLink)
                {
                    var myLink = st.getMyLink(me, row[i]);
                    if (myLink && (st.cache.pop(q + '++' + myLink,  'gc') == 200))
                    {
                        place.textContent = "GC+";
                        place.title = st.str('ext.found');
                    }
                }
                if (me.checkCacheDate)
                {
                    var cachedate = st.cache.pop(q, 'gcd');
                    if (cachedate) me.placeDate(col[me.lay.ico], cachedate);
                }
                place.setAttribute("style", "color:white !important; background-color:green !important;");
                place.href = cache;
            }
            row[i].setAttribute('gc.' + me.ctype, '1');
        }
        col[me.lc].className = col[me.lc].className.replace('a_visited', '');
    }

    st.showAlert(st.str('nice'), st.str('gc.start'), 1, st.google.img);
    me.inProgress = 1;

    var streams = (st.google.seolib || st.google.seobudget)? 3: 1;
    for (var i=0; i < streams; i++) google.next(me, 500 * (i+1));
};


//------------------------------------------------------------------------------
// Проверка PageRank
//------------------------------------------------------------------------------

if (!sape.toolbar.google.rank) sape.toolbar.google.rank =
{
    doc: null,
    lc: -1,
    tc: -1,
    lay: {},
    counter: 0,
    prLimit: 1,         // нижний предел (N)
    prType: false,      // тип проверки: отмечать PageRank меньше заявленного(false) / меньше N(true)
    prMain: false,      // проверять морду вместо страницы
    prZero: true,       // проверять нулевые
    prSkipNA: false,    // не отмечать n/a
    prNoCacheNA: false, // не кэшировать n/a
    inProgress: 0,
    cTimer: 0,

    iPR: ['R0lGODlhLAAQAJEAAAQCBFSSVPz+/JyanCH5BAEAAAIALAAAAAAsABAAAQJbFH6iy62YXAOMLislNvnWb2DIY23lWXLh+KUuNKlUpE7Je4Pj68WcC3rIhjOhg4VM9XZCZcf3jEptm6n1ipUOttyu9wsOdxmBrHkxIJ/PafTa3FaI5/T5+74oKAA7',
          'R0lGODlhLAAQAKIAAAQCBFSSVPz+/JyanFyqXAAAAAAAAAAAACH5BAEAAAIALAAAAAAsABAAAgNiKLAr/jA61mQEED9tLVfdlo0Kx0zal64pWJ5jK1OXi1Xu1cw7ec6iGkhGmtiON6MExmwFf0ZnSDitWnWfq3bLtQ6+4LB4TC6HIQMCIdBtD9Bqdpv7fgwC+Dkdbe77zXqBEQkAOw==',
          'R0lGODlhLAAQAKIAAAQCBFSSVPz+/JyanFyqXAAAAAAAAAAAACH5BAEAAAIALAAAAAAsABAAAgNmKLAr/jA61mQEED9tLVfdlo0Kx0zal64pWJ5jK1OXi1Xu1cw7ec6iGkhGmtiON6MExmwFf0ZnSDitWnWfq3bLtQ6+4LB4TC6HIQOCeh3oagfoNdt9hT8Ggby+Ta/aHWaBgoF9hREJADs=',
          'R0lGODlhLAAQAKIAAAQCBFSSVPz+/JyanFyqXAAAAAAAAAAAACH5BAEAAAIALAAAAAAsABAAAgNqKLAr/jA61mQEED9tLVfdlo0Kx0zal64pWJ5jK1OXi1Xu1cw7ec6iGkhGmtiON6MExmwFf0ZnSDitWnWfq3bLtQ6+4LB4TC6HIQOCes0OdKcDNHtOcL878ccgwO/77XcSeQ5mhYaFgYkRCQA7',
          'R0lGODlhLAAQAKIAAAQCBFSSVPz+/JyanFyqXAAAAAAAAAAAACH5BAEAAAIALAAAAAAsABAAAgNoKLAr/jA61mQEED9tLVfdlo0Kx0zal64pWJ5jK1OXi1Xu1cw7ec6iGkhGmtiON6MExmwFf0ZnSDitWnWfq3bLtQ6+4LB4TC6HIQOCes1mB7qSAbpNX7/haHRgz+/78XkPZoOEg4CHEQkAOw==',
          'R0lGODlhLAAQAKIAAAQCBFSSVPz+/JyanFyqXAAAAAAAAAAAACH5BAEAAAIALAAAAAAsABAAAgNsKLAr/jA61mQEED9tLVfdlo0Kx0zal64pWJ5jK1OXi1Xu1cw7ec6iGkhGmtiON6MExmwFf0ZnSDitWnWfq3bLtQ6+4LB4TC6HIQOCes1urwNdxwDtrrfh8fljEOj7/4B/cQJ6cmaHiGaDixYJADs=',
          'R0lGODlhLAAQAKIAAAQCBFSSVPz+/JyanFyqXAAAAAAAAAAAACH5BAEAAAIALAAAAAAsABAAAgNrKLAr/jA61mQEED9tLVfdlo0Kx0zal64pWJ5jK1OXi1Xu1cw7ec6iGkhGmtiON6MExmwFf0ZnSDitWnWfq3bLtQ6+4LB4TC6HIQOCes1uuwPcAdpNr8O38scgwO/7/4B3WnkOZoaHhl2KVQkAOw==',
          'R0lGODlhLAAQAKIAAAQCBFSSVPz+/JyanFyqXAAAAAAAAAAAACH5BAEAAAIALAAAAAAsABAAAgNqKLAr/jA61mQEED9tLVfdlo0Kx0zal64pWJ5jK1OXi1Xu1cw7ec6iGkhGmtiON6MExmwFf0ZnSDitWnWfq3bLtQ6+4LB4TC6HIQOCes1uu9kBL/pNrxPi1QE6wO/7/4B/cg9mhYaFXYlVCQA7',
          'R0lGODlhLAAQAKIAAAQCBFSSVPz+/JyanFyqXAAAAAAAAAAAACH5BAEAAAIALAAAAAAsABAAAgNuKLAr/jA61mQEED9tLVfdlo0Kx0zal64pWJ5jK1OXi1Xu1cw7ec6iGkhGmtiON6MExmwFf0ZnSDitWnWfq3bLtQ6+4LB4TC6HIQOCes1uu9+EQGeAhtvvarmF/hgE/oCBgoOEf3NoZomKZl2NVQkAOw==',
          'R0lGODlhLAAQAKIAAAQCBFSSVPz+/JyanFyqXAAAAAAAAAAAACH5BAEAAAIALAAAAAAsABAAAgNsKLAr/jA61mQEED9tLVfdlo0Kx0zal64pWJ5jK1OXi1Xu1cw7ec6iGkhGmtiON6MExmwFf0ZnSDitWnWfq3bLtQ6+4LB4TC6HIQOCes1uu9/tABoNr9vd8scAHej7/4CBgoFzemaHiGZdi1UJADs=',
          'R0lGODlhLAAQAKIAAAQCBFSSVPz+/JyanFyqXAAAAAAAAAAAACH5BAEAAAIALAAAAAAsABAAAgNsKLAr/jA61mQEED9tLVfdlo0Kx0zal64pWJ5jK1OXi1Xu1cw7ec6iGkhGmtiON6MExmwFf0ZnSDitWnWfq3bLtQ6+4LB4TC6HIQOCes1uu99wQmCAjtvv7zk6wO/7/4CBgnx0D2aHiIddi1UJADs=',
          'R0lGODlhLAAQAJEAAAQCBJyanOzq7P///yH5BAEAAAMALAAAAAAsABAAAQJkHH6jy62YXAOMLislNvnWb2DIY23lWXLh+KUuNKlUpE7Je4Pj68WcC3rIhjOhg4VM9XZCZcf3jEptm6n1ipUGttyu9wsOdxkBgfmMTqvXbHOA3I7L2e9FeY6f1xXivr+fFRhVAAA7'
         ], // Картинки PR / PageRank images
};

sape.toolbar.google.rank.glue = function(place, link, checkbox)
{
    function clean(link)
    {
        return link.toLowerCase()
                   .replace(/^[^\/]+[\/]+/i, '')
                   .replace(/^www\./i, '')
                   .replace(/\/$/, '');
    }

    var st  = sape.toolbar, google = st.google;

    var q   = google.gc.query(link, 0);
    var url = google.apiURL + st.urlEncode(q);

    var req  = new XMLHttpRequest();
    req.open('GET', url, true);
    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        if (req.status == 200 && req.responseText.length)
        {
            var obj = st.parseJSON(req.responseText);
            if (obj && typeof(obj.responseData.results) == 'object')
            {
                var res = obj.responseData.results;
                if (!res.length) return;
                if ((clean(res[0].url) != clean(link)) && (decodeURIComponent(clean(res[0].url)) != clean(link)))
                {
                    place.title = st.str("gc.glue") + " " + res[0].url;
                    place.style.backgroundColor = "pink";
                    checkbox.checked = true;
                }
            }
        }
    }
    req.send(null);
};

sape.toolbar.google.rank.place = function(row, link, real, rank)
{
    var st  = sape.toolbar, google = st.google, me = google.rank;
    var col = row.getElementsByTagName('td');

    var idt = (rank < 0)? me.iPR[11] : me.iPR[rank];
    var txt = (rank < 0)? 'n/a' : rank;

    var img = me.doc.createElement("img");
        img.setAttribute("src",   "data:image/gif;base64," + idt);
        img.setAttribute("style", "width:44px; height:16px; border:0; margin:3px auto;")

    var a = me.doc.createElement("a");
        a.setAttribute("href", google.requestURL + st.urlEncode(google.gc.query(link, 0)));
        a.setAttribute("target", "_blank");
        a.setAttribute("title", "Page Rank: " + txt);
        a.appendChild(img);

    if (me.lc == me.tc)                     // вывод кнопки в одной колонке с ссылкой
    {
        a.setAttribute("style", "float:right; width:50px; height:20px;");
        col[me.tc].appendChild(a);
    }
    else
    {
        if (me.prMain || (real != rank)) col[me.tc].innerHTML += '&nbsp;(' + txt + ')&nbsp;';
        col[me.tc].appendChild(me.doc.createElement("br"));
        col[me.tc].appendChild(a);
    }

    var o  = col[me.lay.check].getElementsByTagName('input');
    var ch = o[0].checked;

    if (rank > 0 || real > 0) me.glue(img, link, o[0]);

    if (me.prSkipNA && rank == -1) return;  // не отмечаем n/a если опция включена

    if (me.prType || me.prMain)             // меньше N или проверяли морду
    {
        if (!ch && (rank < me.prLimit))
        {
            o[0].checked = true;
            me.counter++;
        }
    }
    else                                    // меньше заявленного
    {
        if (!ch && (real > 0) && (real > rank))
        {
            o[0].checked = true;
            me.counter++;
        }
    }
};

sape.toolbar.google.rank.nextone = function()
{
    var st  = sape.toolbar, google = st.google, me = google.rank;
    var row = me.doc.getElementsByTagName('tr');

    if (me.doc.defaultView) for (var i=0; i < row.length; i++)
    {
        var crow = row[i];
        if (crow.hasAttribute('page_rank')) continue;

        var col = crow.getElementsByTagName('td');
        if (col.length < me.lay.cols) continue;

        var box = col[me.lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;
        if (!st.boxCheck(box[0])) continue;

        if (st.google.skip && box[0].checked) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var link = a[me.lay.idx].getAttribute('href');
        var page_id = (a[me.lay.idx].hasAttribute('page_id') && !me.prMain)? a[me.lay.idx].getAttribute('page_id') : 0;

        if (!st.urlCheck(link)) continue;

        if (me.prMain)
        {
            var host = link.split('/')[2];
            link = 'http://' + host + '/';
        }

        var match, real = -2;
        if (me.lc != me.tc)
        {
            if (match = /\d+/.exec(col[me.tc].innerHTML))  real = parseInt(match[0], 10);
            if (col[me.tc].innerHTML.indexOf('n/a') != -1) real = -1;
        }

        if ((real == 0 || real == -1) && (!me.prZero) && (!me.prMain)) continue;

        var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
        var URI = ioService.newURI(link, 'windows-1251', null);

        var checksum = google.prChecksum(URI.asciiSpec);

        var url = google.toolbarURL + 'info:' + st.urlEncode(URI.asciiSpec) + '&ch=' + checksum;

        if (google.icache)
        {
            var rank = st.cache.pop(URI.asciiSpec, 'pr');
            if (me.prNoCacheNA && rank == -1) rank = null;
            if (rank != null)
            {
                me.place(crow, URI.asciiSpec, real, rank);
                crow.setAttribute('page_rank', '1');
                continue;
            }
        }

        var req  = new XMLHttpRequest();
            req.open('GET', url, true);

        var requestTimer = st.reqTimer(req, 15000);

        req.onreadystatechange = function (aEvt)
        {
            if (req.readyState == 4)
            {
                requestTimer.cancel();
                if (google.isCaptcha(req) && !(req.status == 403))
                {
                    if (!me.cTimer) google.anticaptcha(me, req);
                    crow.removeAttribute('page_rank');
                    return;
                }
                if (req.status == 200 || req.status == 403)
                {
                    var regex = /Rank_\d+:\d+:(\d+)/;
                    var match = regex.exec(req.responseText);
                    var rank  = (match)? match[1] : -1;

                    if (page_id && !me.prMain && real != Math.max(rank, 0)) st.cache.notify('pr', page_id, Math.max(rank, 0));

                    if (google.icache) st.cache.push(URI.asciiSpec, 'pr', rank);
                    return me.place(crow, URI.asciiSpec, real, rank);
                }
                else
                {
                    crow.removeAttribute('page_rank');
                    return;
                }
            }
        }
        req.send(null);
        crow.setAttribute('page_rank', '1');
        google.next(me);
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('pr.finish'), 2, st.google.img);
    }
};

sape.toolbar.google.rank.unload = function()
{
    var me = sape.toolbar.google.rank;

    me.cTimer = 0;
    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.toolbar.google.rank.start = function()
{
    var st = sape.toolbar, google = st.google, me = google.rank;
    if (google.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('pr.stop'), 2, st.google.img);
        return;
    }
    if (me.doc) me.unload();

    var doc = content.document;
    if (!st.inside(doc)) return;

    var prefs = st.prefs();
    var lay   = st.layout(doc);

    google.init();
    google.timeout = Math.max(500, prefs.getIntPref("timeout.pagerank"));

    me.prLimit     = prefs.getIntPref("ranklimit");
    me.prType      = prefs.getBoolPref("ranktype");
    me.prMain      = prefs.getBoolPref("rankmain");
    me.prZero      = prefs.getBoolPref("chkzero");
    me.prSkipNA    = prefs.getBoolPref("rankskip");
    me.prNoCacheNA = prefs.getBoolPref("ranknocache");

    me.lay = lay;
    me.doc = doc;
    me.idx = lay.idx;
    me.lc  = (lay.link < 0)? lay.url : lay.link;
    me.tc  = lay.rank;
    me.counter = 0;

    me.doc.defaultView.addEventListener('unload', me.unload, false);

    if  (me.lc < 0) return;
    if  (me.tc < 0) me.tc = me.lc;

    me.inProgress = 1;

    st.showAlert(st.str('nice'), st.str('pr.start'), 1, st.google.img);
    me.nextone();
};

sape.toolbar.google.prChecksum = function(url)
{
	function getHex(num)
    {
		return (num < 16 ? "0" : "") + num.toString(16);
	}
	function getHex32(num)
    {
        return getHex(num>>>24) + getHex(num>>>16&255) + getHex(num>>>8&255) + getHex(num&255);
    }
	function getHash(value)
    {
		var hash = [77,105,110,105,110,103,32,80,97,103,101,82,97,110,107,32,105,115,32,65,71,65,73,78,83,84,32,71,79,79,71,76,69,39,83,32,84,69,82,77,83,32,79,70,32,83,69,82,86,73,67,69,46,32,89,101,115,44,32,73,39,109,32,116,97,108,107,105,110,103,32,116,111,32,121,111,117,44,32,115,99,97,109,109,101,114,46];
		var k = 16909125;
		for(var i = 0; i < value.length; i++)
        {
		    k ^= hash[i%hash.length] ^ value.charCodeAt(i);
		    k = k>>>23|k<<9;
		}
		return getHex32(k)
	}
    return "8" + getHash(url);
};