if (!sape) var sape={};
if (!sape.mozrank) sape.mozrank =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    lay: {},
    img: "chrome://wmsape/skin/seomoz.png",
    check: {},
    limit: {},
    lvlURL: 'http://www.seomoz.org/users/level',
    apiURL: 'http://lsapi.seomoz.com/linkscape/url-metrics/',
    apiOptions: {'AccessID':'', 'Expires':'', 'Signature':'', 'Cols':'128849070112'},
};

sape.mozrank.ping = function(callback)
{
    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', sape.mozrank.lvlURL, true);

    req.onreadystatechange = function(aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseText.length)
            {
                var acl  = JSON.parse(req.responseText);
                var cols = (acl.level.indexOf('pro') > -1)? '133146078688' : '128849070112';
                sape.mozrank.apiOptions =
                {
                    'AccessID':  decodeURIComponent(acl.access_id),
                    'Expires':   acl.expires,
                    'Signature': decodeURIComponent(acl.signature),
                    'Cols':      cols,
                }
                sape.mozrank.expired = false;
                if (callback) callback();
            }
        }
    }
    req.send(null);
};

sape.mozrank.requestURL = function(link)
{
    var aURI = sape.toolbar.getURI(link);
    var pURL = aURI.host + aURI.path.substring(0, aURI.path.indexOf('#')) + aURI.path.substring(aURI.path.indexOf('#'));

    var options = sape.mozrank.apiOptions;
    var result  = sape.mozrank.apiURL + encodeURIComponent(pURL);

    result += '?AccessID='  + encodeURIComponent(options.AccessID);
    result += '&Expires='   + options.Expires;
    result += '&Signature=' + encodeURIComponent(options.Signature);
    result += '&Cols='      + options.Cols;

    return result;
};

sape.mozrank.show = function(link, place, checkbox, dataString)
{
    var st = sape.toolbar, me = sape.mozrank;
    var res = JSON.parse(dataString);

    var pageAuthority = parseFloat(res.upa);
    var mozRank       = parseFloat(res.umrp);

    var b1 = me.doc.createElement('b');
        b1.style.color = (mozRank < me.limit.mR)? 'red' : 'green';
        b1.style.cursor = 'help';
        b1.title = 'MozRank';
        b1.textContent = 'mR:\xA0';

    var b2 = me.doc.createElement('b');
        b2.style.color = (pageAuthority < me.limit.pA)? 'red' : 'green';
        b2.style.cursor = 'help';
        b2.title = 'Page Authority';
        b2.textContent = 'pA:\xA0';

      place.appendChild(me.doc.createTextNode(' '));
      place.appendChild(b1);
      place.appendChild(me.doc.createTextNode('[' + mozRank.toFixed(2) + ']'));

      place.appendChild(me.doc.createTextNode(' '));
      place.appendChild(b2);
      place.appendChild(me.doc.createTextNode('[' + pageAuthority.toFixed(0) + ']'));

      if (!checkbox.checked)
      {
            var a = (me.check.pA && (pageAuthority < me.limit.pA));
            var b = (me.check.mR && (mozRank < me.limit.mR));

            checkbox.checked = (me.check.both)? a&&b : a||b;
            if (checkbox.checked) me.counter++;
      }
};

sape.mozrank.run = function(link, place, checkbox)
{
    var st = sape.toolbar, me = sape.mozrank;

    var loader = me.doc.createElement('img');
        loader.src = 'http://static.sape.ru/common/img/ajax-loader-plugin.gif';

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', me.requestURL(link), true);

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function(aEvt)
    {
        if (req.readyState == 4)
        {
            requestTimer.cancel();
            place.removeChild(loader);

            if (req.status !== 200)
            {
                place.removeAttribute('mozrank');
                if (sape.mozrank.expired)
                {
                    me.next();
                }
                else
                {
                    me.expired = true;
                    me.ping(me.next);
                }
                return;
            }
            if (req.status == 200 && req.responseText.length)
            {
                if (me.icache) st.cache.push(link, 'moz', req.responseText);

                me.show(link, place, checkbox, req.responseText);
                me.next();
                return;
            }
        }
    }
    place.appendChild(loader);
    req.send(null);
};

sape.mozrank.nextone = function()
{
    var st = sape.toolbar, me = sape.mozrank;
    if (me.inProgress == 0)   return;
    if (sape.mozrank.expired) return me.next();

    var row = me.doc.getElementsByTagName('tr');

    if (me.doc.defaultView) for (var i = me.first; i < row.length; i++)
    {
        var col = row[i].getElementsByTagName('td');
        if (col.length < me.lay.cols) continue;

        var box = col[me.lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;
        if (!st.boxCheck(box[0]) || (box[0].checked && me.skip)) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var link  = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(link)) continue;

        if (!me.first) me.first = i;

        var divs = col[me.lc].getElementsByTagName('div'), place = null, dataString = '';
        if (divs) for (var j=0; j< divs.length; j++)
        {
            if (divs[j].className.indexOf('page_icons') > -1)
            {
                place = divs[j];
                break;
            }
        }
        if (!place)
        {
            var div = me.doc.createElement('div');
            div.className = 'page_icons';
            col[me.lc].appendChild(div);
            place = div;
        }
        if (place && !place.hasAttribute('mozrank'))
        {
            place.setAttribute('mozrank', 1);
            if (me.icache && (dataString = st.cache.pop(link, 'moz')))
            {
                me.show(link, place, box[0], dataString);
                continue;
            }
            else
            {
                me.run(link, place, box[0]);
                return;
            }
        }
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('mozrank.finish'), 2, me.img);
    }
};

sape.mozrank.next = function()
{
    var st = sape.toolbar, me = sape.mozrank;
    if (me.inProgress) st.setTimer(me.nextone, (arguments.length)? arguments[0] : 250);
};

sape.mozrank.unload = function()
{
    var me = sape.mozrank;

    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.mozrank.start = function()
{
    var st = sape.toolbar, me = sape.mozrank;
    if (!st.inside(content.document)) return;

    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('mozrank.stop'), 2, me.img);
        return;
    }
    if (me.doc) me.unload();

    var lay = st.layout(content.document);

    if ((me.lc = (lay.url == -1)? lay.link : lay.url) < 0) return;

    me.lay = lay;
    me.doc = content.document;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    var prefs = st.prefs();
    me.counter    = 0;
    me.first      = 0;
    me.inProgress = 1;
    me.icache     = prefs.getBoolPref("cache");
    me.skip       = prefs.getBoolPref("re.check.ext");
    me.check.mR   = prefs.getBoolPref("mozrank.check.mr");
    me.check.pA   = prefs.getBoolPref("mozrank.check.pa");
    me.check.both = prefs.getBoolPref("mozrank.check.both");
    me.limit.mR   = prefs.getIntPref("mozrank.limit.mr");
    me.limit.pA   = prefs.getIntPref("mozrank.limit.pa");

    st.showAlert(st.str('nice'), st.str('mozrank.start'), 1, me.img);

    me.expired = true;
    me.ping(me.next);

    var streams = Math.min(5, Math.max(1, prefs.getIntPref("streams"))) - 1;
    for (var i=0; i < streams; i++) me.next(500*(i+1));
};