if (!sape) var sape={};
if (!sape.toolbar) sape.toolbar={};

//------------------------------------------------------------------------------
// LiveInternet
//------------------------------------------------------------------------------

if (!sape.toolbar.liru) sape.toolbar.liru =
{
    baseline: 'http://counter.yadro.ru/values?site=',
    infourl: 'http://www.liveinternet.ru/stat/',
    checkit: true,
    checkna: true,
    limit: 1000,
};

sape.toolbar.liru.show = function(host, place, text)
{
    var st = sape.toolbar, me = st.liru, doc = place.ownerDocument;
    var lhost = host.split('/')[2].replace(/^www./i, '');

    var l = doc.createElement('a');
        l.target = '_blank';
        l.href   = me.infourl + encodeURIComponent(lhost) + '/';
        l.style.color = 'black';
        l.appendChild(doc.createTextNode(text));

    var b = doc.createElement('b');
        b.style.color = 'green';
        b.style.cursor = 'help';
        b.title = "LiveInternet.ru";
        b.innerHTML = 'LI:&nbsp;';

    place.appendChild(doc.createTextNode(' '));
    place.appendChild(b);
    place.appendChild(doc.createTextNode('['));
    place.appendChild(l);
    place.appendChild(doc.createTextNode(']'));
};

sape.toolbar.liru.run = function(host, place, checkbox)
{
    var st = sape.toolbar, me = st.liru, doc = place.ownerDocument;
    var lhost = host.split('/')[2].replace(/^www./i, '');

    var url = me.baseline + encodeURIComponent(lhost);

    var loader = doc.createElement('b');
        loader.style.color = 'green';
        loader.innerHTML = '&nbsp;...';

    if  (place.hasAttribute("liru_rank")) return;
    else place.setAttribute("liru_rank", 1);

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', url, true);

    var requestTimer = st.reqTimer(req, 15000);

    req.onreadystatechange = function (aEvt)
    {
        var correct = 0;
        if (req.readyState == 4)
        {
                requestTimer.cancel();
                if (loader) place.removeChild(loader);

                if (req.status == 200 && req.responseText.length)
                {
                    var s, exp = /LI_month_vis\s\=\s([0-9]+)/;
                    if (s = exp.exec(req.responseText))
                    {
                        if (s.length)
                        {
                            var vis = parseInt(s[1], 10);
                            me.show(host, place, vis); correct = 1;

                            if (me.checkit && (vis < me.limit)) checkbox.checked = true;
                            if (st.traffic.icache) st.cache.push(host, 'liru', vis);
                        }
                    }
                    if ((req.responseText.indexOf('Unregistered site') > -1) && st.traffic.icache) st.cache.push(host, 'liru', 'n/a');
                }
                if (!correct)
                {
                    me.show(host, place, 'n/a');
                    checkbox.setAttribute('noliru', 1);
                    st.traffic.checkIt(checkbox);
                }
                st.traffic.next(500);
        }
    }
    place.appendChild(loader);
    req.send(null);
};

//------------------------------------------------------------------------------
// Alexa Rank
//------------------------------------------------------------------------------

if (!sape.toolbar.alexa) sape.toolbar.alexa =
{
    baseline: 'http://data.alexa.com/data/?cli=10&ver=alxf-2.01&url=',
    infourl: 'http://www.alexa.com/siteinfo/',
    checkit: false,
    checkna: false,
    limit: 20000,
};


sape.toolbar.alexa.show = function(host, place, text)
{
    var st = sape.toolbar, me = st.alexa, doc = place.ownerDocument;

    var l = doc.createElement('a');
        l.target = '_blank';
        l.href   = me.infourl + encodeURIComponent(host.split('/')[2]);
        l.style.color = 'black';
        l.appendChild(doc.createTextNode(text));

    var b = doc.createElement('b');
        b.style.color = 'green';
        b.style.cursor = 'help';
        b.title = "Alexa rank";
        b.innerHTML = 'AL:&nbsp;';

    place.appendChild(doc.createTextNode(' '));
    place.appendChild(b);
    place.appendChild(doc.createTextNode('['));
    place.appendChild(l);
    place.appendChild(doc.createTextNode(']'));
};

sape.toolbar.alexa.run = function(host, place, checkbox)
{
    var st = sape.toolbar, me = st.alexa, doc = place.ownerDocument;
    var url = me.baseline + encodeURIComponent(host);

    var loader = doc.createElement('b');
        loader.style.color = 'green';
        loader.innerHTML = '&nbsp;...';

    if  (place.hasAttribute("alexa_rank")) return;
    else place.setAttribute("alexa_rank", 1);

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');

    var requestTimer = st.reqTimer(req, 15000);

    req.onreadystatechange = function (aEvt)
    {
        var correct = 0;
        if (req.readyState == 4)
        {
                requestTimer.cancel();
                if (loader) place.removeChild(loader);

                if (req.status == 200 && req.responseText.length)
                {
                    var xml = req.responseXML;
                    var rank = xml.getElementsByTagName("POPULARITY")
                    if (rank && rank.length)
                    {
                        var text = parseInt(rank[0].getAttribute("TEXT"), 10);
                        me.show(host, place, (text/1000).toFixed()); correct = 1;

                        if (me.checkit && (me.limit * 1000 < text)) checkbox.checked = true;
                        if (st.traffic.icache) st.cache.push(host, 'alexa', text);
                    }
                }
                if (!correct)
                {
                    me.show(host, place, 'n/a');
                    checkbox.setAttribute('noalexa', 1);
                    st.traffic.checkIt(checkbox);
                }
                st.traffic.next(500);
        }
    }
    place.appendChild(loader);
    req.send(null);
};

//------------------------------------------------------------------------------
// SEMRush
//------------------------------------------------------------------------------

if (!sape.toolbar.semrush) sape.toolbar.semrush =
{
    api:  'http://publicapi.semrush.com/wmsape/',
    goto: 'http://www.semrush.com/search.php',
    checkit: false,
    checkna: false,
    limit: 100,
    key: '',
    img: '',
};

sape.toolbar.semrush.show = function(host, place, text)
{
    var st = sape.toolbar, me = st.semrush, doc = place.ownerDocument;

    var l = doc.createElement('a');
        l.target = '_blank';
        l.title  = st.str('semrush.goto');
        l.href   = me.goto + '?db=' + me.base + '&q=' + host.split('/')[2];
        l.style.color = 'black';
        l.appendChild(doc.createTextNode(text));

    var b = doc.createElement('b');
        b.style.color = 'blue';
        b.style.cursor = 'help';
        b.title = sape.toolbar.str('semrush.help');
        b.innerHTML = 'GT:&nbsp;';

    place.appendChild(doc.createTextNode(' '));
    place.appendChild(b);
    place.appendChild(doc.createTextNode('['));
    place.appendChild(l);
    place.appendChild(doc.createTextNode(']'));
};

sape.toolbar.semrush.run = function(host, place, checkbox)
{
    var st = sape.toolbar, me = st.semrush, doc = place.ownerDocument;
    var url = me.api + me.base + '/info.php?url=' + st.urlEncode(host.split('/')[2]);

    var loader = doc.createElement('b');
        loader.style.color = 'blue';
        loader.innerHTML = '&nbsp;...';

    if  (place.hasAttribute("semrush_rank")) return;
    else place.setAttribute("semrush_rank", 1);

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', url, true);

    var requestTimer = st.reqTimer(req, 15000);

    req.onreadystatechange = function (aEvt)
    {
        var correct = 0;
        if (req.readyState == 4)
        {
                requestTimer.cancel();
                if (loader) place.removeChild(loader);

                if (req.status == 200 && req.responseText.length)
                {
                    var error  = req.responseText.match(/ERROR\s(\d+)/);
                    if (!error && req.responseXML)
                    {
                        var status = req.responseXML.getElementsByTagName("status");
                        if (status && status[0].textContent == 'ok')
                        {
                            var traffic = req.responseXML.getElementsByTagName("traffic");
                            if (traffic)
                            {
                                var text = parseInt(traffic[0].textContent, 10);
                                me.show(host, place, text); correct = 1;

                                if (me.checkit && me.limit > text) checkbox.checked = true;
                                if (st.traffic.icache) st.cache.push(host, 'rush' + '.' + me.base, text);
                            }
                        }
                    }
                    if (error)
                    {
                        var errn = parseInt(error[1], 10);
                        if (errn < 50)
                        {
                            st.showAlert(st.str('bad'), st.str('semrush.error.' + errn), 0, me.img);
                            st.semrush.checkit = false;
                            st.semrush.checkna = false;
                            correct = 1;
                        }
                    }
                }
                if (!correct)
                {
                    me.show(host, place, 'n/a');
                    checkbox.setAttribute('nosemrush', 1);
                    st.traffic.checkIt(checkbox);
                }
                st.traffic.next(500);
        }
    }
    place.appendChild(loader);
    req.send(null);
};

//------------------------------------------------------------------------------
// Проверка трафика
//------------------------------------------------------------------------------

if (!sape.toolbar.traffic) sape.toolbar.traffic =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    idx: 0,
    lay: {},
    icache: true,
    img: "chrome://wmsape/skin/isemrush.png",
};

sape.toolbar.traffic.next = function()
{
    var st = sape.toolbar, me = st.traffic;
    if (me.inProgress) st.setTimer(me.nextone, (arguments.length)? arguments[0] : 250);
};

sape.toolbar.traffic.nextone = function()
{
    var st = sape.toolbar, me = st.traffic;
    if (!me.inProgress) return;

    var row = me.doc.getElementsByTagName('tr');

    if (me.doc.defaultView) for (var i=0; i < row.length; i++)
    {
        var col = row[i].getElementsByTagName('td');
        if (col.length < me.lay.cols) continue;

        var box = col[me.lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.idx + 1) continue;

        var link  = a[me.idx].getAttribute('href');
        if (!st.urlCheck(link)) continue;

        var host = link.split('/')[2];
            host = 'http://' + host + '/';

        var divs = col[me.lc].getElementsByTagName('div'), place = null;
        if (divs) for (var j=0; j< divs.length; j++)
        {
            if (divs[j].className.indexOf('page_icons') > -1)
            {
                place = divs[j];
                break;
            }
        }
        if (!place)
        {
            var div = me.doc.createElement('div');
            div.className = 'page_icons';
            col[me.lc].appendChild(div);
            place = div;
        }

        var nos = (place.hasAttribute('semrush_rank') || !(st.semrush.checkit || st.semrush.checkna));
        var noa = (place.hasAttribute('alexa_rank') || !(st.alexa.checkit || st.alexa.checkna));
        var nol = (place.hasAttribute('liru_rank') || !(st.liru.checkit || st.liru.checkna));
        if (nos && noa && nol) continue;

        var _cache;
        if (me.icache && !noa)
        {
                _cache = st.cache.pop(host, 'alexa');
                if (_cache !== null)
                {
                    st.alexa.show(host, place, (_cache / 1000).toFixed());
                    if (st.alexa.checkit && (_cache > st.alexa.limit * 1000)) box[0].checked = true;
                    place.setAttribute('alexa_rank', 1);
                }
        }
        if (me.icache && !nos)
        {
                _cache = st.cache.pop(host, 'rush' + '.' + st.semrush.base);
                if (_cache !== null)
                {
                    st.semrush.show(host, place, _cache);
                    if (st.semrush.checkit && (_cache < st.semrush.limit)) box[0].checked = true;
                    place.setAttribute('semrush_rank', 1);
                }
        }
        if (me.icache && !nol)
        {
                _cache = st.cache.pop(host, 'liru');
                if (_cache !== null)
                {
                    st.liru.show(host, place, _cache);
                    place.setAttribute('liru_rank', 1);
                    if (st.liru.checkit && (_cache !== 'n/a') && (parseInt(_cache, 10) < st.liru.limit)) box[0].checked = true;
                    if (st.liru.checkna && (_cache  == 'n/a'))
                    {
                        box[0].setAttribute('noliru', 1);
                        me.checkIt(box[0]);
                    }
                }
        }
        if ((st.alexa.checkna || st.alexa.checkit) && !place.hasAttribute('alexa_rank'))
        {
            st.alexa.run(host, place, box[0]);
            return;
        }
        if ((st.semrush.checkna || st.semrush.checkit) && !place.hasAttribute('semrush_rank'))
        {
            st.semrush.run(host, place, box[0]);
            return;
        }
        if ((st.liru.checkit || st.liru.checkna) && !place.hasAttribute('liru_rank'))
        {
            st.liru.run(host, place, box[0]);
            return;
        }
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('nice'), st.str('semrush.finish'), 2, me.img);
    }
};

sape.toolbar.traffic.checkIt = function(checkbox)
{
    var st = sape.toolbar, me = st.traffic, v1, v2;
    if (me.together)
    {
        v1 = 1 +  st.semrush.checkna + st.alexa.checkna + st.liru.checkna;
        v2 = 1 + (st.semrush.checkna && checkbox.hasAttribute('nosemrush')) + (st.alexa.checkna && checkbox.hasAttribute('noalexa')) + (st.liru.checkna && checkbox.hasAttribute('noliru'));
        if ((v1 > 1) && (v2 >= v1)) checkbox.checked = true;
    }
    else
    {
        if (st.semrush.checkna && checkbox.hasAttribute('nosemrush')) checkbox.checked = true;
        if (st.alexa.checkna   && checkbox.hasAttribute('noalexa'))   checkbox.checked = true;
        if (st.liru.checkna    && checkbox.hasAttribute('noliru'))    checkbox.checked = true;
    }
};

sape.toolbar.traffic.unload = function()
{
    var me = sape.toolbar.traffic;

    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.toolbar.traffic.start = function()
{
    var st = sape.toolbar, me = st.traffic;
    if (!st.inside(content.document)) return;

    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('bad'), st.str('semrush.stop'), 2, me.img);
        return;
    }
    if (me.doc) me.unload();

    me.doc = content.document;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    var lay = st.layout(me.doc);
    me.lc   = (lay.url == -1)? lay.link : lay.url;
    me.idx  = lay.idx;
    me.lay  = lay;

    if (me.lc < 0) return;

    var prefs = st.prefs();
    me.icache   = prefs.getBoolPref("cache");
    me.together = prefs.getBoolPref("traff.together");

    st.semrush.checkit = prefs.getBoolPref("semrush.check");
    st.semrush.checkna = prefs.getBoolPref("semrush.check.na");
    st.semrush.limit   = prefs.getIntPref("semrush.amount");
    st.semrush.base    = prefs.getCharPref("semrush.base");

    st.alexa.checkit = prefs.getBoolPref("alexa.check");
    st.alexa.checkna = prefs.getBoolPref("alexa.check.na");
    st.alexa.limit   = prefs.getIntPref("alexa.amount");

    st.liru.checkit = prefs.getBoolPref("liru.check");
    st.liru.checkna = prefs.getBoolPref("liru.check.na");
    st.liru.limit   = prefs.getIntPref("liru.amount");

    var streams = 1;
    if (st.liru.checkit || st.liru.checkna) streams++;
    if (st.alexa.checkit || st.alexa.checkna) streams++;
    if (st.semrush.checkit || st.semrush.checkna) streams++;

    if (streams == 1) return;

    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('semrush.start'), 1, me.img);

    for (var i=0; i<streams; i++) me.next(500 * (i+1));
};