if (!sape) var sape={};
if (!sape.sleeps) sape.sleeps =
{
    bgc: "pink",
    show: true,
};


//------------------------------------------------------------------------------
// Функции инициализации
//------------------------------------------------------------------------------

sape.sleeps.init = function(aEvent)
{
    var doc = aEvent.originalTarget;
    if (doc instanceof HTMLDocument)
    {
        if (!doc.location.href.match(/sape.ru/i)) return;
        if (!doc.location.href.match(/site_links/i)) return;

        var prefs = sape.toolbar.prefs();

        sape.sleeps.bgc   = prefs.getCharPref("bgcolor").replace(/[^0-9a-z#]+/ig,"");
        sape.sleeps.show  = prefs.getBoolPref("showalerts");

        sape.sleeps.buttonPlace(doc);
    }
    else return;
};

//------------------------------------------------------------------------------
// Функции интерфейса
//------------------------------------------------------------------------------

sape.sleeps.buttonPlace = function(doc)
{
    var divs = doc.getElementsByTagName('div');
    for (var i=0; i< divs.length; i++)
    {
        if (divs[i].className.indexOf("sorter_list") > -1) break;
    }
    if (i == divs.length) return;

    var link_1 = doc.createElement("a");
        link_1.setAttribute("rel", "M");
        link_1.setAttribute("title", sape.toolbar.str('sleep.title.m'));
        link_1.setAttribute("style", "cursor:pointer");
        link_1.textContent = "SLEEP M";
        link_1.addEventListener("click", sape.sleeps.check, false);

    var span_1 = doc.createElement("span");
        span_1.appendChild(link_1);
        span_1.appendChild(doc.createTextNode('\xA0\xA0'));

    var link_2 = doc.createElement("a");
        link_2.setAttribute("rel", "B");
        link_2.setAttribute("style", "cursor:pointer");
        link_2.setAttribute("title", sape.toolbar.str('sleep.title.b'));
        link_2.textContent = "SLEEP B";
        link_2.addEventListener("click", sape.sleeps.check, false);

    var span_2 = doc.createElement("span");
        span_2.appendChild(link_2);
        span_2.appendChild(doc.createTextNode('\xA0\xA0'));

    divs[i].appendChild(span_1);
    divs[i].appendChild(span_2);
};

//------------------------------------------------------------------------------
// Функции обработки заявок
//------------------------------------------------------------------------------
sape.sleeps.check = function(aEvent)
{
    var st = sape.toolbar, total = 0;

    var lnk = aEvent.originalTarget;
    var rel = lnk.getAttribute("rel");
    var doc = content.document;
    var lay = sape.toolbar.layout(doc);

    var row  = doc.getElementsByTagName('tr');
    for (var i=0; i < row.length; i++)
    {
         var col = row[i].getElementsByTagName('td');
         if (col.length < lay.cols) continue;

         if (col[0].textContent.indexOf('SLEEP')   > -1)
         if (col[0].textContent.indexOf(rel + ':') > -1)
         {
                var o = col[lay.check].getElementsByTagName('input');
                if (!o[0].checked)
                {
                    total++;
                    o[0].checked = true;
                }
                sape.filters.decorate(row[i], sape.sleeps.bgc);
         }
    }
    if (sape.sleeps.show) st.showAlert(st.str('links.checked') + total, st.str('ya.finish'), 2);
};

window.addEventListener("DOMContentLoaded", sape.sleeps.init, false);