if (!sape) var sape={};
if (!sape.toolbar) sape.toolbar={};

sape.toolbar.xml =
{
  address: 'http://xmlsearch.yandex.ru/xmlsearch',
};


sape.toolbar.xml.init = function()
{
    sape.toolbar.xml.address = sape.toolbar.prefs().getCharPref("xml.address").replace(/(^\s+)|(\s+$)/g, '');
};

sape.toolbar.xml.isError = function(req, me)
{
    var st = sape.toolbar, result = req.responseXML;
    var e  = result.getElementsByTagName("error");
    if (e.length)
    {
        var code = e[0].getAttribute("code");
        var text = st.str('xml.error');
        if (code != null) text += ' (' + code + ')';

        if (code == 15) return 0; // ничего не найдено
        if (code == 10001) return 10001;  // слишком длинный запрос

        if (me.inProgress)
        {
            st.showAlert(st.str('bad'), text, 2);
            me.inProgress = 0;
        }
        return 1;
    }
    return 0;
};

sape.toolbar.xml.inIndex  = function(req)
{
    var st = sape.toolbar, xml = req.responseXML;

    var e  = xml.getElementsByTagName("error");
    if (e.length) return 0;

    var results = xml.getElementsByTagName("response");
    if (results.length)
    {
        var found = results[0].getElementsByTagName("found");
        if (found.length)
        {
            return parseInt(found[0].textContent, 10);
        }
    }
    return 0;
};


// -----------------------------------------------
// Проверка проиндексированности страницы (YAP)
// -----------------------------------------------

sape.toolbar.xml.yap = function(link, place, checkbox, crow)
{
    var st = sape.toolbar, ya = st.ya, me = ya.yap;

    var page   = link.replace(/^https?[^\/]*[\/]*/, '').replace(/^www\./i, '').replace(/\/$/, '');
    var q      = st.safeEncode('(url:"' + page + '" | url:"www.' + page + '")');
    var url    = st.xml.address;
    var age    = st.cache.age(link, 'history');

    if (url.indexOf('?') == -1)
        url += '?query=' + q;
    else
        url += '&query=' + q;

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseText.length)
            {
                   requestTimer.cancel();

                   var host  = link.split("/")[2].replace(/^www\./i, '').toLowerCase();
                   var lhost = 'http://' + host + '/';

                   var err = st.xml.isError(req, me);
                   var is  = st.xml.inIndex(req);

                   if (err == 1)    return crow.removeAttribute('yap');
                   if (err == 1001) is = -1;

                   if (is > 0)
                   {
                       st.cache.del(link, 'history');
                       place.setAttribute("style", "color:white !important; background-color:green !important;");
                       if (ya.icache)
                       {
                           st.cache.push(link,   'yap.' + ya.yandexcheck, 200);
                       }
                   }
                   if (is == 0)
                   {
                       if (!age && me.lay.history) st.cache.push(link, 'history', 404);
                       if (age) place.setAttribute("title", st.str('yap.noindex') + ' (' + (age/3600).toFixed() + 'h)');

                       place.setAttribute("style", "color:white !important; background-color:red !important;");
                       if (!(checkbox.checked) && ((age <= me.history.age) && me.history.use))
                       {
                           place.setAttribute("style", "color:white !important; background-color:#FF6666 !important;");
                       }
                       if (!(checkbox.checked) && ((age > me.history.age) || !me.history.use))
                       {
                             checkbox.checked = true;
                             me.counter++;
                       }
                       if (ya.icache) st.cache.push(link, 'yap.' + ya.yandexcheck, 404);
                   }
                   if (is < 0)
                   {
                        place.setAttribute("style", "color:white !important; background-color:silver !important;");
                        if (ya.errcheck && !(checkbox.checked) && !(me.history.use))
                        {
                            checkbox.checked = true;
                            me.counter++;
                        }
                   }
            }
            else
            {
                    requestTimer.cancel();
                    place.setAttribute("style", "color:white !important; background-color:silver !important;");
                    if (ya.errcheck && !(checkbox.checked) && !(me.history.use))
                    {
                        checkbox.checked = true;
                        me.counter++;
                    }
            }
        }
    }
    try {req.send(null)} catch(e) {req.abort()}

    if (me.inProgress) ya.next(ya.yap);
};

// -----------------------------------------------
// Проверка проиндексированности ссылки (YAL)
// -----------------------------------------------

sape.toolbar.xml.yal = function(link, text, place, checkbox, crow)
{
    var st = sape.toolbar, ya = st.ya, me = ya.yal;

    var page       = link.replace(/^https?[^\/]*[\/]*/, '').replace(/^www\./i, '').replace(/\/$/, '');
    var q          = st.safeEncode(text + ' (url:"' + page + '" | url:"www.' + page + '")');
    var url        = st.xml.address;

    var host  = link.split("/")[2].replace(/^www\./i, '');
    var hlink = 'http://' + host + '/';
    var clink = link + '++' + text;
    var age   = st.cache.age(clink, 'history');

    if (url.indexOf('?') == -1)
        url += '?query=' + q;
    else
        url += '&query=' + q;

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseText.length)
            {
                   requestTimer.cancel();

                   var err = st.xml.isError(req, me);
                   var is  = st.xml.inIndex(req);

                   if (err == 1)    return crow.removeAttribute('yal');
                   if (err == 1001) is = -1;

                   if (is > 0)
                   {
                       st.cache.del(link, 'history');
                       st.cache.del(clink, 'history');
                       place.setAttribute("style", "color:white !important; background-color:green !important;");
                       if (ya.icache)
                       {
                           st.cache.push(clink, 'yal.' + ya.yandexcheck,  200);
                           st.cache.push(link,  'yap.' + ya.yandexcheck,  200);
                       }
                   }
                   if (is == 0)
                   {
                       if (!age && me.lay.history) st.cache.push(clink, 'history', 404);
                       if (age) place.setAttribute("title", st.str('yal.noindex') + ' (' + (age/3600).toFixed() + 'h)');

                       place.setAttribute("style", "color:white !important; background-color:red !important;");
                       if (!(checkbox.checked) && ((age <= me.history.age) && me.history.use))
                       {
                            place.setAttribute("style", "color:white !important; background-color:#FF6666 !important;");
                       }
                       if (!(checkbox.checked) && ((age > me.history.age) || !me.history.use))
                       {
                             checkbox.checked = true;
                             me.counter++;
                       }
                       if (ya.icache) st.cache.push(clink, 'yal.' + ya.yandexcheck, 404);
                   }
                   if (is < 0  && !(me.history.use))
                   {
                        place.setAttribute("style", "color:white !important; background-color:silver !important;");
                        if (ya.errcheck && !(checkbox.checked))
                        {
                            checkbox.checked = true;
                            me.counter++;
                        }
                   }
            }
            else
            {
                    requestTimer.cancel();
                    place.setAttribute("style", "color:white !important; background-color:silver !important;");
                    if (ya.errcheck && !(checkbox.checked)  && !(me.history.use))
                    {
                        checkbox.checked = true;
                        me.counter++;
                    }
            }
        }
    }
    try {req.send(null)} catch(e) {req.abort()}

    if (me.inProgress) ya.next(ya.yal);
};

// -----------------------------------------------
// Проверка релевантности анкоров
// -----------------------------------------------

sape.toolbar.xml.relevancy = function(link, text, place, checkbox, crow)
{
    var st = sape.toolbar, ya = st.ya, me = ya.relevancy;

    var page       = link.replace(/^https?[^\/]*[\/]*/, '').replace(/^www\./i, '').replace(/\/$/, '');
    var q          = st.safeEncode(text + ' (url:"' + page + '" | url:"www.' + page + '")');
    var url        = st.xml.address;

    if (url.indexOf('?') == -1)
        url += '?query=' + q;
    else
        url += '&query=' + q;

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseText.length)
            {
                   requestTimer.cancel();

                   var host  = link.split("/")[2].replace(/^www\./i, '');
                   var hlink = 'http://' + host + '/';
                   var clink = link + '++' + text;

                   var err = st.xml.isError(req, me);
                   var is  = st.xml.inIndex(req);

                   if (err == 1)    return crow.removeAttribute('relevance');
                   if (err == 1001) is = -1;

                   if (is > 0)
                   {
                       place.setAttribute("style", "color:white !important; background-color:green !important;");
                       if (ya.icache)
                       {
                           st.cache.push(clink, 'yal.' + ya.yandexcheck,  200);
                           st.cache.push(link,  'yap.' + ya.yandexcheck,  200);
                       }
                   }
                   if (is == 0)
                   {
                       place.setAttribute("style", "color:white !important; background-color:red !important;");
                       if (!(checkbox.checked))
                       {
                             checkbox.checked = true;
                             me.counter++;
                       }
                       if (ya.icache) st.cache.push(clink, 'yal.' + ya.yandexcheck, 404);
                   }
                   if (is < 0)
                   {
                        place.setAttribute("style", "color:white !important; background-color:silver !important;");
                        if (ya.errcheck && !(checkbox.checked))
                        {
                            checkbox.checked = true;
                            me.counter++;
                        }
                   }
            }
            else
            {
                    requestTimer.cancel();
                    place.setAttribute("style", "color:white !important; background-color:silver !important;");
                    if (ya.errcheck && !(checkbox.checked))
                    {
                        checkbox.checked = true;
                        me.counter++;
                    }
            }
            if (me.inProgress) ya.next(ya.relevancy);
        }
    }
    try {req.send(null)} catch(e) {req.abort()}
};

// -----------------------------------------------
// Проверка проиндексированности сайта (HOST)
// -----------------------------------------------

sape.toolbar.xml.host = function(link, place, checkbox, crow)
{
    var st = sape.toolbar, ya = st.ya, me = ya.host;
    var host   = link.split("/")[2].replace(/^www\./i, '').toLowerCase();
    var q      = st.safeEncode('host:"' + host + '" | host:"www.' + host + '"');
    var url    = st.xml.address;
    var clink  = 'http://' + host + '/';
    if (me.regionCheck)
    {
            clink += '++' + me.regionNumber;
            if (url.indexOf('?') == -1)
                url += '?rstr=-' + me.regionNumber + '&lr=' + me.regionNumber;
            else
                url += '&rstr=-' + me.regionNumber + '&lr=' + me.regionNumber;
    }
    if (url.indexOf('?') == -1)
        url += '?query=' + q;
    else
        url += '&query=' + q;

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseText.length)
            {
                   requestTimer.cancel();

                   var err = st.xml.isError(req, me);
                   var is  = st.xml.inIndex(req);

                   if (err == 1)    return crow.removeAttribute('host');
                   if (err == 1001) is = -1;

                   if (is > 0)
                   {
                       place.setAttribute("style", "color:white !important; background-color:green !important;");
                   }
                   if (is == 0)
                   {
                       place.setAttribute("style", "color:white !important; background-color:red !important;");
                       if (!(checkbox.checked))
                       {
                             checkbox.checked = true;
                             me.counter++;
                       }
                   }
                   if (is > -1)
                   {
                       if (ya.icache) st.cache.push(clink, 'host.' + ya.yandexcheck, is);
                   }
                   if (is > -1 && me.showcounters)
                   {
                       var col = crow.getElementsByTagName('td');
                       me.placeCounter(col[me.lc], is);
                   }
                   if (is < 0)
                   {
                        place.setAttribute("style", "color:white !important; background-color:silver !important;");
                        if (ya.errcheck && !(checkbox.checked))
                        {
                            checkbox.checked = true;
                            me.counter++;
                        }
                   }
            }
            else
            {
                    requestTimer.cancel();
                    place.setAttribute("style", "color:white !important; background-color:silver !important;");
                    if (ya.errcheck && !(checkbox.checked))
                    {
                        checkbox.checked = true;
                        me.counter++;
                    }
            }
        }
    }
    try {req.send(null)} catch(e) {req.abort()}

    if (me.inProgress) ya.next(ya.host);
};
